#include "C4_topologie.h"

/****************************************************************/
/*	Fonctions utilisees pour construire les projections	*/
/****************************************************************/

projection_list *
C4_projection_addprojname (projection_list * T, char *name)
{
  projection_list *TAB;
  int dblFICTIVE;
  dblFICTIVE = 0;
  if (T)
    if (!(strcmp (name, C4_FICTIVE)) && !(strcmp (T->NOM, C4_FICTIVE)))
      dblFICTIVE = 1;
  if (!(dblFICTIVE))
    {
      TAB = malloc (sizeof *TAB);
      TAB->NEXT = NULL;
      TAB->NOM = name;
      TAB->NEXT = T;
      return TAB;
    }
  return T;
}


projection_list *
C4_projection_genproj (projection_list * T, ablexpr * abl)
{
  ablexpr *pt;
  projection_list *TAB;
  pt = abl;
  TAB = T;
  if (ABL_ATOM (abl))
    return TAB = C4_projection_addprojname (T, ABL_ATOM_VALUE (abl));
  else
    while (ABL_CDR (pt))
      {
	pt = ABL_CDR (pt);
	TAB = C4_projection_genproj (TAB, ABL_CAR (pt));

      }
  return TAB;
}

void 
C4_projection_affproj (projection_list * TAB)
{
  projection_list *pt;
  pt = TAB;
  while (pt)
    {
      //   if (strcmp(pt->NOM,C4_FICTIVE))
      printf ("%s : %s %s\n", pt->NOM, getsigname (pt->GAUCHE), getsigname (pt->DROITE));
      // else printf ("%s : RIEN RIEN\n",pt->NOM); //,getsigname(pt->GAUCHE));
      pt = pt->NEXT;
    }
}

projection_list *
C4_projection_loadproj (lofig_list * LOFIG, befig_list * BEFIG, char TYPE)
{
  char *name;
  projection_list *TAB, *pt;
  lotrs_list *trans;
//losig_list *prev;
  //prev=NULL;
  TAB = C4_projection_addprojname (NULL, C4_FICTIVE);	//Juste histoire de bien delimiter nos bandes On peut l'oublier

  TAB = C4_projection_genproj (TAB, BEFIG->BEOUT->ABL);
  TAB = C4_projection_addprojname (TAB, C4_FICTIVE);	//idem

  pt = TAB;
//if (TYPE==TRANSN) strcpy(prefixe,"tn_"); else strcpy(prefixe,"tp_");
  while (pt)
    {
      if ((strcmp (pt->NOM, C4_FICTIVE)))
	{
	  name = malloc ((strlen (pt->NOM) + 4) * sizeof (char));
	  if (TYPE == TRANSN)
	    strcpy (name, "tn_");
	  else
	    strcpy (name, "tp_");
	  strcat (name, pt->NOM);
	  trans = getlotrs (LOFIG, name);
	  pt->GAUCHE = trans->DRAIN->SIG;
	  pt->DROITE = trans->SOURCE->SIG;
	  //prev=pt->DROITE;
	}
      else
	{
	  pt->GAUCHE = NULL;
	  pt->DROITE = NULL;
	}
      pt = pt->NEXT;
    }
  return TAB;
}

int 
C4_reunit (projection_list * TAB)
{
  if (!(TAB))
    return 1;
  if ((TAB->NEXT) && (strcmp (TAB->NEXT->NOM, C4_FICTIVE)))
    {
      if (TAB->DROITE == TAB->NEXT->DROITE)
	{
	  TAB->NEXT->DROITE = TAB->NEXT->GAUCHE;
	  TAB->NEXT->GAUCHE = TAB->DROITE;
	}
      else if (TAB->DROITE != TAB->NEXT->GAUCHE)
	return 0;
      return C4_reunit (TAB->NEXT);
    }
  else
    return 1;
}

projection_list *
C4_projection_projete_1 (projection_list * TAB)
{
  losig_list *i;
  i = malloc (20 * sizeof (char));
  if (!(TAB))
    {
      return TAB;
    }
  if (strcmp (TAB->NOM, C4_FICTIVE))
    {
      TAB->NEXT = C4_projection_projete_1 (TAB->NEXT);
      return TAB;
    }
  if (C4_reunit (TAB->NEXT) != 1)
    {
      i = TAB->NEXT->GAUCHE;
      TAB->NEXT->GAUCHE = TAB->NEXT->DROITE;
      TAB->NEXT->DROITE = i;
      C4_reunit (TAB->NEXT);
    }
  C4_projection_projete_1 (TAB->NEXT);
  return TAB;
}

projection_list *
C4_projection_symetrique (projection_list * PROJ)
{
  projection_list *new, *last, *pt;
  pt = PROJ;
  last = NULL;
  while (pt)
    {
      new = malloc (sizeof *new);
      new->NEXT = last;
      new->GAUCHE = pt->DROITE;
      new->DROITE = pt->GAUCHE;
      new->NOM = pt->NOM;
      last = new;
      pt = pt->NEXT;
    }
  return new;
}

projection_list *
C4_projete (lofig_list * LOFIG, befig_list * BEFIG, char type)
{
  projection_list *PROJ, *pt;
  losig_list *sig;
  sig = NULL;
  PROJ = C4_projection_loadproj (LOFIG, BEFIG, type);
  PROJ = C4_projection_projete_1 (PROJ);
  pt = PROJ;
  while (pt)
    {
      if (strcmp (pt->NOM, C4_FICTIVE))
	sig = pt->DROITE;
      else
	{
	  pt->GAUCHE = sig;
	  if (pt->NEXT)
	    pt->DROITE = pt->NEXT->GAUCHE;
	}
      pt = pt->NEXT;
    }
  return PROJ;
}

/****************************************************************/
/*	Fonctions utilisees pour construire la topologie	*/
/****************************************************************/

int
C4_topo_getlen (projection_list * PROJ)
{
  int i, t;
  projection_list *pt;
  pt = PROJ;
  i = 0;
  t = 0;
  while (pt)
    {
      if (pt->GAUCHE == PROJ->GAUCHE)
	t = i;
      pt = pt->NEXT;
      i++;
    }
  return t;
}

C4_listproj_list *
C4_topo_addlistproj (C4_listproj_list * LIST, projection_list * PROJ, C4_instance_list * TOPO)
{
  C4_listproj_list *NEW;
  NEW = malloc (sizeof *NEW);
  NEW->DATA = PROJ;
  NEW->TAILLE = C4_topo_getlen (PROJ);
  NEW->TOP = TOPO;
  NEW->NEXT = NULL;
  if (LIST == NULL)
    return NEW;
  if (NEW->TAILLE > LIST->TAILLE)
    {
      NEW->NEXT = LIST;
      return NEW;
    }
  LIST->NEXT = C4_topo_addlistproj (LIST->NEXT, PROJ, TOPO);
  return LIST;
}

C4_listproj_list *
C4_topo_loadlistproj (projection_list * PROJ, C4_instance_list * TOPO)
{
  projection_list *pproj;
  C4_instance_list *ptopo;
  C4_listproj_list *NEW;
  ptopo = TOPO;
  pproj = PROJ;
  NEW = NULL;
  while (ptopo)
    {
      NEW = C4_topo_addlistproj (NEW, pproj, ptopo);
      pproj = pproj->NEXT;
      ptopo = ptopo->NEXT;
    }
  return NEW;
}

C4_instance_list *
C4_topo_addinstance (C4_instance_list * TOPO, char *name)
{
  int i;
  C4_instance_list *NEW;
  if (TOPO == NULL)
    {
      NEW = malloc (sizeof *NEW);
      NEW->NOM = name;
      NEW->NEXT = TOPO;
      for (i = 0; i < C4_NBTOT; i++)
	{
	  NEW->VIA[i] = 0;
	  NEW->SIG[i] = NULL;
	  NEW->INDEX = 0;
	}
      return NEW;
    }
  NEW = C4_topo_addinstance (TOPO->NEXT, name);
  NEW->INDEX = TOPO->INDEX + 1;
  TOPO->NEXT = NEW;
  return TOPO;
}

void
C4_topo_afftopo (C4_instance_list * TOPO)
{
  int i;
  C4_instance_list *pt;
  pt = TOPO;
  while (pt)
    {
      printf ("%d %s:\t|", pt->INDEX, pt->NOM);
      for (i = C4_NBTOT - 1; i >= 0; i--)
	{
	  if (pt->VIA[i])
	    printf ("X");
	  if (pt->SIG[i])
	    printf (" %s\t|", getsigname (pt->SIG[i]));
	  else
	    printf ("\t|");
	}
      printf ("\t:%s\n", pt->NOM);
      pt = pt->NEXT;
    }
}

void
C4_topo_add_VddVss (C4_instance_list * TOPO, projection_list * PN, projection_list * PP)
{
  projection_list *pn, *pp;
  C4_instance_list *pt;
  pn = PN;
  pp = PP;
  pt = TOPO;
  while (pt)
    {
      if ((pp->GAUCHE) && (pp->GAUCHE->INDEX == 2))
	{
	  pt->SIG[0] = pp->GAUCHE;
	  pt->VIA[0] = 1;
	}
      if ((pn->GAUCHE) && (pn->GAUCHE->INDEX == 3))
	{
	  pt->SIG[C4_NBTOT - 1] = pn->GAUCHE;
	  pt->VIA[C4_NBTOT - 1] = 1;
	}
      pp = pp->NEXT;
      pn = pn->NEXT;
      pt = pt->NEXT;
    }
}

C4_instance_list *
C4_topo_loadtopo (projection_list * PN, projection_list * PP)
{
  projection_list *pn, *pp;
  C4_instance_list *topo;
  topo = NULL;
  pn = PN;
  pp = PP;
  while (pn)
    {
      topo = C4_topo_addinstance (topo, pn->NOM);
      pn = pn->NEXT;
    }
  C4_topo_add_VddVss (topo, PN, PP);
  return topo;
}

projection_list *
C4_topo_extremite_droite (losig_list * SIGNAL, projection_list * EXTREMITE, projection_list * BANDE)
{
  if (BANDE == NULL)
    return EXTREMITE;
  if (BANDE->GAUCHE == SIGNAL)
    return C4_topo_extremite_droite (SIGNAL, BANDE, BANDE->NEXT);
  return C4_topo_extremite_droite (SIGNAL, EXTREMITE, BANDE->NEXT);
}

/****************************************************************/
/*	Fonction C4_topo_placeseg() 				*/
/****************************************************************/

int
C4_topo_placeseg (C4_instance_list *TOPO, int RANG, projection_list *BANDE)
{
  int place;
  C4_instance_list *pt;
  projection_list *pb, *extremite;

  place = 1;
  pt = TOPO;
  pb = BANDE;
  if ((BANDE->GAUCHE->INDEX == 2) || (BANDE->GAUCHE->INDEX == 3))
    return place;
  extremite = C4_topo_extremite_droite (BANDE->GAUCHE, BANDE, BANDE);
  if (extremite == BANDE)
    return 1;
  while ((pb != extremite->NEXT) && (place))
    {
      if (pt->SIG[RANG])
	if (pt->SIG[RANG] != BANDE->GAUCHE)
	  place = 0;
      pb = pb->NEXT;
      pt = pt->NEXT;
    }
  if (place)
    {
      pt = TOPO;
      pb = BANDE;
      while (pb != extremite->NEXT)
	{
	  pt->SIG[RANG] = BANDE->GAUCHE;
	  if (pb->GAUCHE == BANDE->GAUCHE)
	    pt->VIA[RANG] = 1;
	  pt = pt->NEXT;
	  pb = pb->NEXT;
	}
    }
  return place;
}

/****************************************************************/
/*	Fonction C4_topo_route()    				*/
/****************************************************************/

C4_instance_list *
C4_topo_route (projection_list * PPN, projection_list * PPP, 
		lofig_list * LOFIG,int INV)
{
  C4_listproj_list *listeP, *listeN;
  C4_instance_list *TOPO;
  losig_list *sortie;
  projection_list *pbn, *pbp, *PN, *PP;
  int i, segment_non_place;

  sortie = getlosig (LOFIG, 1);
  pbn = PPN;
  pbp = PPP;
  PN = PPN;
  PP = PPP;
  TOPO = C4_topo_loadtopo (PN, PP);
  listeP = C4_topo_loadlistproj (PP, TOPO);
  listeN = C4_topo_loadlistproj (PN, TOPO);

  pbn = PN;
  pbp = PP;

  PP->GAUCHE =sortie;
  C4_topo_placeseg (TOPO,1, PP);
    
  while (listeP)
    {
      segment_non_place = 1;
      for (i = 1; i < C4_NBP; i++)
	if (listeP->TOP->SIG[i] == listeP->DATA->GAUCHE)
	
	  segment_non_place = 0;
      if ((listeP->DATA->GAUCHE) && ((listeP->DATA->GAUCHE->INDEX > 3)/* || (listeP->DATA->GAUCHE->INDEX == 0)*/) && segment_non_place)
	{
	  for (i = 1; i < C4_NBP; i++)
	    i = i + C4_NBP * C4_topo_placeseg (listeP->TOP, i, listeP->DATA);
	  if (i == C4_NBP)
		{
                if (INV) return (0);
                else
                	{ PN=C4_projection_symetrique(PN); 
			  PP=C4_projection_symetrique(PP);
			  return C4_topo_route (PN,PP,LOFIG,1);} 
		}
	}
      listeP = listeP->NEXT;
    }

  PN->GAUCHE=sortie;
  C4_topo_placeseg (TOPO, C4_NBTOT -2, PN);

  while (listeN)
    {
      segment_non_place = 1;
      for (i = C4_NBTOT - 2; i > C4_NBTOT - C4_NBN; i--)
	if (listeN->TOP->SIG[i] == listeN->DATA->GAUCHE)
	  segment_non_place = 0;
      if ((listeN->DATA->GAUCHE) && ((listeN->DATA->GAUCHE->INDEX > 3)/* || (listeN->DATA->GAUCHE->INDEX == 0)*/) && segment_non_place)
	{
	  for (i = C4_NBTOT - 2; i > C4_NBTOT - C4_NBN -1; i--)
	    i = i - C4_NBN * C4_topo_placeseg (listeN->TOP, i, listeN->DATA);
	  if (i == C4_NBTOT - C4_NBN-1)
		{
	  	if (INV)  return (0);
          	else
                	{ PN=C4_projection_symetrique(PN);
			  PP=C4_projection_symetrique(PP);
			  return C4_topo_route (PN,PP,LOFIG,1);} 
		}
	}
      listeN = listeN->NEXT;
    }
  return (TOPO);
}

/****************************************************************/
/*	Fonction C4_topo_genereseg()				*/
/****************************************************************/

C4_segment_list *
C4_topo_addseg (C4_segment_list * LIST, 
		C4_instance_list * ref1, int index1, 
		C4_instance_list * ref2, int index2,
		losig_list * sig)
{
  C4_segment_list *NEW;
  NEW = malloc (sizeof *NEW);
  NEW->NEXT = LIST;
  NEW->REF1 = ref1;
  NEW->REF2 = ref2;
  NEW->INDEX1 = index1;
  NEW->INDEX2 = index2;
  NEW->SIG = sig;
  return NEW;
}

//////////////////////////////////////////////////////////////////

C4_segment_list *
C4_topo_genereseg (C4_instance_list * INS, C4_segment_list * LIST)
{
  C4_instance_list *pt, *REF2;
  int i;
  REF2 = malloc (sizeof *REF2);
  if (INS->NEXT)
    {
      for (i = 1; i < C4_NBTOT - 1; i++)
	{
	  if ((INS->VIA[i]) && (INS->NEXT->SIG[i] == INS->SIG[i]))
	    {
	      pt = INS->NEXT;
	      while (pt)
		{
		  if ((pt->NEXT) && (pt->NEXT->SIG[i] == pt->SIG[i]))
		    pt = pt->NEXT;
		  else
		    {
		      REF2 = pt;
		      pt = NULL;
		    }
		}
	      LIST = C4_topo_addseg (LIST, INS, i, REF2, i, INS->SIG[i]);
	    }
	}
      LIST = C4_topo_genereseg (INS->NEXT, LIST);
    }
  return LIST;
}

/****************************************************************/
/*	Fonctions d'affichage()					*/
/****************************************************************/

void
C4_fig_affseglist (C4_segment_list * SEG)
{
  printf ("%s : %s %d , %s %d\n", getsigname (SEG->SIG), SEG->REF1->NOM, SEG->INDEX1, SEG->REF2->NOM, SEG->INDEX2);
  if (SEG->NEXT)
    C4_fig_affseglist (SEG->NEXT);
}
void
C4_aff_fig (C4_fig_route * FIG)
{
  printf ("\nFig Name: %s\n", FIG->NOM);
  printf ("\nInstance List :\n");
  C4_topo_afftopo (FIG->INS);
  printf ("\nSegment List :\n");
  C4_fig_affseglist (FIG->SEG);
}

/****************************************************************/
/*	Fonction C4_topologie()					*/
/****************************************************************/

C4_fig_route *
C4_topologie (lofig_list * LOFIG, befig_list * BEFIG)
{
  projection_list *TN, *TP;
  C4_instance_list *TOPO;
  C4_fig_route *C4FIG;

  TN = C4_projete (LOFIG, BEFIG, TRANSN);
  TP = C4_projete (LOFIG, BEFIG, TRANSP);

  TOPO = C4_topo_route (TN, TP, LOFIG,0);
  if (TOPO == (C4_instance_list *) 0) return (0);

  C4FIG = malloc (sizeof *C4FIG);
  C4FIG->NOM = LOFIG->NAME;
  C4FIG->INS = TOPO;
  C4FIG->SORTIE = getsigname(getlosig(LOFIG,1));

  TOPO->VIA[1] = 1;
  TOPO->VIA[C4_NBTOT - 2] = 1;
  C4FIG->SEG = C4_topo_genereseg (TOPO, NULL);
  TOPO->VIA[1] = 0;
  TOPO->VIA[C4_NBTOT - 2] = 0;

  return (C4FIG);
}
