/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*********************************************************************\

    File        :    placer_create_con.h

    Date        :   30-06-94
    Version     :   1

    Auteur      :   BEAURIN oliver

\*********************************************************************/

#ifndef PLACER_CREATE_CON_H
#define PLACER_CREATE_CON_H

/*---------------------------------------------------------\
                     includes
\---------------------------------------------------------*/
#include "placer_structure.h"

/*---------------------------------------------------------\
                     prototypes
\---------------------------------------------------------*/
#ifdef __STDC__

extern void create_con_list_for_routed_bloc     ( column * );
extern void create_con_list_for_column          ( column * );
extern void create_con_list_for_placed_bloc     ( column * );
extern PlaceConList *create_con_for_glue_placing( placement *, column * );

#else

extern void create_con_list_for_routed_bloc     ( );
extern void create_con_list_for_column          ( );
extern void create_con_list_for_placed_bloc     ( );
extern PlaceConList *create_con_for_glue_placing( );

#endif

#endif /* PLACER_CREATE_CON_H */
