/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*********************************************************************\

    File        :    placer_create_grid.h

    Date        :    27-09-1994
    Version     :    1.0

    Auteur      :    BEAURIN oliver

\*********************************************************************/

#ifndef PLACER_CREATE_GRID
#define PLACER_CREATE_GRID

/*---------------------------------------------------------\
                     includes
\---------------------------------------------------------*/
#include MUT_H
#include MLO_H
#include MPH_H

#include "placer_structure.h"

/*---------------------------------------------------------\
                     prototypes
\---------------------------------------------------------*/

#ifdef __STDC__

extern alim   *create_alim_list_from_connectors( phcon_list * );
extern alim   *create_alim_list_two_levels     ( char * );
extern slice  *create_slice_list               ( slice *, char *, char *, long, char );
extern slice  *create_slice_list_for_glue      ( char *, char *, long );
extern column *create_column_one_level         ( column *, char *, char *, char );
extern void    create_column_two_level         ( column *, char * );

#else

extern alim   *create_alim_list_from_connectors( );
extern alim   *create_alim_list_two_levels     ( );
extern slice  *create_slice_list               ( );
extern slice  *create_slice_list_for_glue      ( );
extern column *create_column_one_level         ( );
extern void    create_column_two_level         ( );

#endif

#endif /* PLACER_CREATE_GRID */
