/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*********************************************************************\

    Fichier     :    strecher_phtalu.h

    Date        :    12 octobre 1995
    Version     :    2.0

    Auteur      :    CHAPUT Jean-Paul
    Modifie par :    BEAURIN Oliver

\*********************************************************************/

#ifndef PHTALU_H
#define PHTALU_H

/* Constantes du module : */
#define        F_PHTALU_CMA          1L
#define        F_PHTALU_TALU1        2L
#define        F_PHTALU_TALU2        4L


/* Structure commune, codant tous les types de gabarits de
   transparence. */
typedef struct phtalu
{
    char            TYPE;       /* type du gabarit                   */
    long            X1;         /* abcsisse mini (gabarit initial)   */
    long            X2;         /* abcsisse maxi (gabarit initial)   */
    long            YTALU;      /* ordonnee des pseudo-segments INTV */
    long            WIDTH;      /* largeur des pseudo-segments INTV  */
    long            NBREF;      /* nombre de refernce ajoutee (CMA)  */
    struct ptype   *PPHSEG;     /* segments secants (pour un CMA)    */
    struct ptype   *PPHREF;     /* references sur la transparence    */
    struct intv    *INTV;       /* gabarit autorise                  */
    struct phcma   *PHCMA;      /* CMA de rattachement (pour MAPCMA) */
    struct phtalu  *NEXT;       /* chainage                          */
}               phtalu_list;


/* Fonctions du module visibles pour l'exterieur. */
extern void     alloc_ls_talu();
extern void     trunc_ls_talu();
extern void     ls_talutoseg();
extern void     free_ls_talu();
extern void     modify_ls_talu();
extern void     addphcomp();
extern void     check_ls_through();
extern void     clean_ls_through();
extern void     add_ls_through();
extern void     export_ls_through();
extern void     save_ls_cma();
extern void     init_phtalu();

#endif                          /* PHTALU_H */
