/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */



/*
 * %% \textrm{This File Looks Nicer with\textsf{ LGrind} and \LaTeXe.}       %%
 * %|                                                                        |%
 * %| $Id: UtEnv.c,v 1.2 2001/05/21 15:29:20 czo Exp $          |%
 * %|                                                                        |%
 * %| /--------------------------------------------------------------------\ |%
 * %| |                                                                    | |%
 * %| |          Alliance CAD System 3.2b                                   | |%
 * %| |     F p G e n   P a c k a g e   1.10                               | |%
 * %| |                                                                    | |%
 * %| |  Copyright(c) 95-97, MASI, CAO-VLSI Team                           | |%
 * %| |                                                                    | |%
 * %| |  Author    :            Jean-Paul CHAPUT                           | |%
 * %| |  E-mail    :        cao-vlsi@masi.ibp.fr                           | |%
 * %| | ================================================================== | |%
 * %| |  Module    :        "UtEnv.c"                                      | |%
 * %| | ****************************************************************** | |%
 * %| |                                                                    | |%
 * %| \--------------------------------------------------------------------/ |%
 * %|                                                                        |%
 */


# include  <stdio.h>
# include  <stdlib.h>

# include  "GenericGN.h"


/*
 *   %| /----------------------------------------------------------------\ |%
 *   %| |             External Structures and Variables                  | |%
 *   %| \----------------------------------------------------------------/ |%
 *   %|                                                                    |%
 *   %| All those variables must be declared `extern' in "GenericGN.h".    |%
 */

       UtEnv_Environ_t  UtEnv_Environ = {
         (char*)NULL,  /* Techno Path Name. */
         };


/*
 *   %| /----------------------------------------------------------------\ |%
 *   %| |             Internal Structures and Variables                  | |%
 *   %| \----------------------------------------------------------------/ |%
 */

static long  LV_mId;  /* "UtEnv.c" module identifier. */


/*
 * %| /--------------------------------------------------------------------\ |%
 * %| |                                                                    | |%
 * %| |                     Functions Definitions                          | |%
 * %| |                                                                    | |%
 * %| \--------------------------------------------------------------------/ |%
 */

/*
 * %| /--------------------------------------------------------------------\ |%
 * %| |  Function  :  "UtEnv_Init()"                                       | |%
 * %| \--------------------------------------------------------------------/ |%
 */

extern void  UtEnv_Init()
{
  static long  FirstCall = TRUE;

  if (FirstCall == FALSE) return;
    FirstCall = FALSE;
  /* Attribution of a module identifier. */
  LV_mId = GfpUT_GetModuleId( "UtEnv", F_GfpUT_ModuleAdd );
  /* Reading environment variables. */
  UtEnv_Environ.RDS_TECHNO_NAME = mbkgetenv( "RDS_TECHNO_NAME" );
  UtEnv_Environ.FPGEN_LIB       = mbkgetenv( "FPGEN_LIB" );
  UtEnv_Environ.FPGEN_TARGET    = mbkgetenv( "FPGEN_TARGET" );
}


