/*
 * $Author: ac $
 * $Id: bflrandom.c,v 1.1 1999/10/21 12:51:52 ac Exp $
 * $Date: 1999/10/21 12:51:52 $
 */
/*
 * $Log: bflrandom.c,v $
 * Revision 1.1  1999/10/21 12:51:52  ac
 * Nouvelle version avec les librairies bdd104, abe, abv, abt.
 * Ajout de fpm_network pour accelerer l'optimisation.
 *
 */

/*----------------------------------------------------------------------*/
/*                               Includes                               */
/*----------------------------------------------------------------------*/

#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>
#include  BFL_H

/*----------------------------------------------------------------------*/
/*                        Constant declarations                         */
/*----------------------------------------------------------------------*/

#define IA	1103515245u
#define IC	12345u
#define IM	2147483648u

/*----------------------------------------------------------------------*/
/*                          Type declarations                           */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Stucture declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Variable declarations                         */
/*----------------------------------------------------------------------*/

static unsigned int current_random = 0;

/*----------------------------------------------------------------------*/
/*                          Macro declarations                          */
/*----------------------------------------------------------------------*/

#define mklcpr(x)               ((0xDEECE66D * (x) + 0x2BBB62DC) >> 1)

/*----------------------------------------------------------------------*/
/*                      Static function prototypes                      */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                    Definition of static functions                    */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                   Definition of exported functions                   */
/*----------------------------------------------------------------------*/

int
bflirand(int imax)
{
	int ival;
	    
	current_random = current_random * IA + IC;
	ival = current_random & (IM - 1);
/*	ival = (int) ((float) ival * (float) (imax + 0.999) / (float) IM); */
	ival = (int) ((float) ival * (float) imax / (float) IM);
			
	return ival;
}

float
bflfrand(void)
{
	float fval;
	int ival;
		
	current_random = current_random * IA + IC;
	ival = current_random & (IM - 1);
	fval = (float) ival / (float) IM;
			    
	return fval;
}

void
bflsrand(unsigned int seed)
{
	int pid, ppid;
	struct timeval tv;
	struct timezone tz;
	int a, b;
		
	if (seed != 0) {
		current_random = seed;
		printf(" + random_seed = %d\n", current_random);
	} else {
		pid  = getpid();
		ppid = getppid();
		if (gettimeofday(&tv, &tz) != 0)
			perror("can't get time of day");
		a = mklcpr(tv.tv_usec);
		b = mklcpr(pid + tv.tv_sec + (ppid << 12));
		current_random = mklcpr(a + b);
	}
}
