/*
 * $Author: ac $
 * $Id: testmap.c,v 1.2 1999/10/21 12:51:54 ac Exp $
 * $Date: 1999/10/21 12:51:54 $
 */
/*
 * $Log: testmap.c,v $
 * Revision 1.2  1999/10/21 12:51:54  ac
 * Nouvelle version avec les librairies bdd104, abe, abv, abt.
 * Ajout de fpm_network pour accelerer l'optimisation.
 *
 * Revision 1.1.1.1  1998/10/21 16:32:38  alliance
 * fpmap import
 *
 */

#include <stdio.h>
#include BFL_H

int
main(int argc, char **argv)
{
    bflmap_t *map;
    bflmapnode_t *first;
    bflmapnode_t *last;

    map = bflmapnew(bflstrcmp, 0);

    bflmapinsert(map, "tata", "tata esl bo");
    bflmapinsert(map, "tata", "tata esl bo");
    bflmapinsert(map, "tate", "tata esl bo");
    bflmapinsert(map, "tati", "tata esl bo");
    bflmapinsert(map, "tato", "tata esl bo");
    bflmapinsert(map, "tatu", "tata esl bo");

    bflmapinsert(map, "teta", "tata esl bo");
    bflmapinsert(map, "tete", "tata esl bo");
    bflmapinsert(map, "teti", "tata esl bo");
    bflmapinsert(map, "teto", "tata esl bo");
    bflmapinsert(map, "tetu", "tata esl bo");

    bflmapinsert(map, "tita", "tata esl bo");
    bflmapinsert(map, "tite", "tata esl bo");
    bflmapinsert(map, "titi", "titi esl bo");
    bflmapinsert(map, "tito", "tata esl bo");
    bflmapinsert(map, "titu", "tata esl bo");

    printf("--> map ( size = %d ) <--\n", bflmapsize(map));
    first = bflmapbegin(map);
    last = bflmapend(map);
    while (first != last) {
	printf("key = %s\tdata = %s\n",
	       (char *) bflmapkey(first), (char *) bflmapdata(first));
	first = bflmapnext(first);
    }
    puts("<-- map -->");

    bflmapremove(map, "tati");
    bflmapremove(map, "teto");
    bflmapremove(map, "titu");

    printf("--> map ( size = %d ) <--\n", bflmapsize(map));
    first = bflmapbegin(map);
    last = bflmapend(map);
    while (first != last) {
	printf("key = %s\tdata = %s\n",
	       (char *) bflmapkey(first), (char *) bflmapdata(first));
	first = bflmapnext(first);
    }
    puts("<-- map -->");

    bflmapclean(map);
    printf("--> map ( size = %d ) <--\n", bflmapsize(map));
    first = bflmapbegin(map);
    last = bflmapend(map);
    while (first != last) {
	printf("key = %s\tdata = %s\n",
	       (char *) bflmapkey(first), (char *) bflmapdata(first));
	first = bflmapnext(first);
    }
    puts("<-- map -->");

    bflmapfree(map);

    return 0;
}
