/*
 * $Author: ac $
 * $Id: fpm_user.h,v 1.1 1999/10/21 12:52:07 ac Exp $
 * $Date: 1999/10/21 12:52:07 $
 */
/*
 * $Log: fpm_user.h,v $
 * Revision 1.1  1999/10/21 12:52:07  ac
 * Nouvelle version avec les librairies bdd104, abe, abv, abt.
 * Ajout de fpm_network pour accelerer l'optimisation.
 *
 */

#ifndef __fpm_user_h
#define __fpm_user_h

/*----------------------------------------------------------------------*/
/*                           Nested includes                            */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Constant declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                          Macro declarations                          */
/*----------------------------------------------------------------------*/

#ifndef __P
# ifdef __STDC__
#  define __P(args)	args
# else
#  define __P(args)	()
# endif
#endif

/*----------------------------------------------------------------------*/
/*                          Type declarations                           */
/*----------------------------------------------------------------------*/

typedef void	 (*fpm_init_fn)   __P((void));
typedef void	 (*fpm_done_fn)   __P((void));
typedef void	 (*fpm_check_fn)  __P((void));
typedef void	 (*fpm_cost_fn)   __P((fpm_expr_t *, long *, long *));
typedef void	 (*fpm_clear_fn)  __P((fpm_atom_t *));
typedef ablexpr *(*fpm_mapp_fn)   __P((bddnode *, int));
typedef void	 (*fpm_report_fn) __P((void));
typedef void	 (*fpm_save_fn)   __P((void));

typedef struct fpm_user {
	char		*ARCHI_NAME;
	fpm_init_fn	 ARCHI_INIT;
	fpm_done_fn	 ARCHI_DONE;
	fpm_check_fn	 ARCHI_CHECK;
	fpm_cost_fn	 ARCHI_COST;
	fpm_clear_fn	 ARCHI_CLEAR;
	fpm_mapp_fn	 ARCHI_MAPP;
	fpm_report_fn	 ARCHI_REPORT;
	fpm_save_fn	 ARCHI_SAVE;
	int		 LEVEL;
	int		 MODE;
	int		 ABL_ORDER;
	int		 FLATTEN;
	int		 IOB_MODE;
	int		 KLUT_SIZE;
	chain_list	*SAVED_AUX;
	chain_list	*CLOCKS;
	char		*FILE_VHDL;
	char		*FILE_PARAM;
	char		*FILE_EXPR;
	befig_list	*BEFIG;
	fpm_network_t	*NETWORK;
} fpm_user_t;

/*----------------------------------------------------------------------*/
/*                        Stucture declarations                         */
/*----------------------------------------------------------------------*/

/*----------------------------------------------------------------------*/
/*                        Variable declarations                         */
/*----------------------------------------------------------------------*/

extern fpm_user_t *FpmUser;

/*----------------------------------------------------------------------*/
/*                         Function prototypes                          */
/*----------------------------------------------------------------------*/

#endif /* __fpm_user_h */
