/*
   ### -------------------------------------------------- ### 
   $Author: hcl $
   $Date: 2001/09/26 14:27:48 $
   $Log: findNPointsPath.c,v $
   Revision 1.1  2001/09/26 14:27:48  hcl
   premier commit....

   Revision 1.3  2000/02/26 00:25:22  root
   2 points OK

   Revision 1.2  2000/02/19 14:45:26  root
   *** empty log message ***

   Revision 1.1  2000/02/19 00:13:07  root
   Initial revision

   ### -------------------------------------------------- ###
 */

#include <stdlib.h>
#include MUT_H
#include MLO_H
#include MLU_H
#include MPH_H
#include MPU_H

#include "ocr.h"
#include "ocrWRoutingDataBase.h"
#include "ocrWindow.h"
#include "ocrPath.h"
#include "display.h"

#include "ocrConnectorUtil.h"
#include "ocrNpoints.h"
#include "ocrSignalUtil.h"

static char *res_id =
   "$Id: findNPointsPath.c,v 1.1 2001/09/26 14:27:48 hcl Exp $";

#define MAX_HT 500
#define SCALE_X 100

#define FINDPATH findPathBetween2Points
#define FINDNPATH findPathNPoints

extern ocrOption *g_pOption;

#define LEVEL (g_pOption->LEVEL)

void
unifyPoint (ocrWRoutingGrid * i_pGrid,
            ocrRoutingParameters * i_pParam,
            ocrSignal * i_pSignal,
            ocrNaturalInt i_uXPoint,
            ocrNaturalInt i_uYPoint, ocrNaturalInt i_uZPoint)
{
   ocrWSegment *l_pSegment;
   ocrWSegment *l_pSegment1;
   ocrWSegment *l_pSegment2;
   ocrNaturalInt i;
   ocrNaturalInt l_uIndex;

   l_pSegment1 = getWSegment (i_pGrid, i_uXPoint, i_uYPoint, i_uZPoint);
   l_uIndex = l_pSegment1->SIGNAL_INDEX;

   if (getWSegDirection (i_pParam, l_pSegment1) == ocrHorizontal)
     {
        if (l_pSegment1->P_MAX < i_pGrid->SIZE_H - 1)
          {
             l_pSegment2 = getWSegment (i_pGrid,
                                        l_pSegment1->P_MAX + 1,
                                        i_uYPoint, i_uZPoint);

             if (l_pSegment2->SIGNAL_INDEX == l_uIndex)
               {
                  l_pSegment = createWSegment (i_uYPoint,
                                               i_uZPoint,
                                               l_pSegment1->P_MIN,
                                               l_pSegment2->P_MAX, l_uIndex);

                  // mise  jour de la liste des segments du signal
                  deleteSegmentSignalList (i_pSignal, l_pSegment1);
                  deleteSegmentSignalList (i_pSignal, l_pSegment2);

                  // puts ("ajout");
                  addSegmentSignalList (i_pSignal, l_pSegment);

                  // mise  jour de la grille
                  for (i = l_pSegment1->P_MIN; i <= l_pSegment2->P_MAX; i++)
                     setWGrid (i_pGrid, l_pSegment, i, i_uYPoint, i_uZPoint);
               }
          }

        if (l_pSegment1->P_MIN > 0)
          {
             l_pSegment2 = getWSegment (i_pGrid,
                                        l_pSegment1->P_MIN - 1,
                                        i_uYPoint, i_uZPoint);

             if (l_pSegment2->SIGNAL_INDEX == l_uIndex)
               {
                  l_pSegment = createWSegment (i_uYPoint,
                                               i_uZPoint,
                                               l_pSegment2->P_MIN,
                                               l_pSegment1->P_MAX, l_uIndex);

                  // mise  jour de la liste des segments du signal
                  deleteSegmentSignalList (i_pSignal, l_pSegment1);
                  deleteSegmentSignalList (i_pSignal, l_pSegment2);

                  // puts ("ajout");
                  addSegmentSignalList (i_pSignal, l_pSegment);

                  // mise  jour de la grille
                  for (i = l_pSegment2->P_MIN; i <= l_pSegment1->P_MAX; i++)
                     setWGrid (i_pGrid, l_pSegment, i, i_uYPoint, i_uZPoint);
               }
          }
     }
   else
     {
        if (l_pSegment1->P_MAX < i_pGrid->SIZE_V - 1)
          {
             l_pSegment2 = getWSegment (i_pGrid,
                                        i_uXPoint,
                                        l_pSegment1->P_MAX + 1, i_uZPoint);

             if (l_pSegment2->SIGNAL_INDEX == l_uIndex)
               {
                  l_pSegment = createWSegment (i_uXPoint,
                                               i_uZPoint,
                                               l_pSegment1->P_MIN,
                                               l_pSegment2->P_MAX, l_uIndex);

                  // mise  jour de la liste des segments du signal
                  deleteSegmentSignalList (i_pSignal, l_pSegment1);
                  deleteSegmentSignalList (i_pSignal, l_pSegment2);

                  // puts ("ajout");
                  addSegmentSignalList (i_pSignal, l_pSegment);

                  for (i = l_pSegment1->P_MIN; i <= l_pSegment2->P_MAX; i++)
                     setWGrid (i_pGrid, l_pSegment, i_uXPoint, i, i_uZPoint);
               }
          }

        if (l_pSegment1->P_MIN > 0)
          {
             l_pSegment2 = getWSegment (i_pGrid,
                                        i_uXPoint,
                                        l_pSegment1->P_MIN - 1, i_uZPoint);

             if (l_pSegment2->SIGNAL_INDEX == l_uIndex)
               {
                  l_pSegment = createWSegment (i_uXPoint,
                                               i_uZPoint,
                                               l_pSegment2->P_MIN,
                                               l_pSegment1->P_MAX, l_uIndex);

                  // mise  jour de la liste des segments du signal
                  deleteSegmentSignalList (i_pSignal, l_pSegment1);
                  deleteSegmentSignalList (i_pSignal, l_pSegment2);

                  // puts ("ajout");
                  addSegmentSignalList (i_pSignal, l_pSegment);

                  for (i = l_pSegment2->P_MIN; i <= l_pSegment1->P_MAX; i++)
                     setWGrid (i_pGrid, l_pSegment, i_uXPoint, i, i_uZPoint);
               }
          }
     }
}

void
addSegmentToEqui (ocrRoutingParameters * i_pParam,
                  ocrWRoutingGrid * i_pGrid,
                  ocrWSegment * i_pSegment,
                  ocrVirtualConnector ** i_pVirConList)
{
   ocrNaturalInt i;
   ocrWSegment *l_pSegment;

   if (getWSegDirection (i_pParam, i_pSegment) == ocrHorizontal)
     {
        for (i = i_pSegment->P_MIN; i <= i_pSegment->P_MAX; i++)
          {
             if (i_pSegment->LAYER > 0)
               {
                  l_pSegment = getWSegment (i_pGrid,
                                            i,
                                            i_pSegment->OFFSET,
                                            i_pSegment->LAYER - 1);

                  if ((l_pSegment->SIGNAL_INDEX == WSEGMENT_FREE) ||
                      (l_pSegment->SIGNAL_INDEX == i_pSegment->SIGNAL_INDEX))
                    {

                       addVirtualConnector (i_pVirConList,
                                            createVirtualConnector (i,
                                                                    i_pSegment->
                                                                    OFFSET,
                                                                    i_pSegment->
                                                                    LAYER - 1,
                                                                    0, 0));

                    }
               }
             else if (i_pSegment->LAYER < i_pGrid->NB_OF_LAYERS - 1)
               {
                  l_pSegment = getWSegment (i_pGrid,
                                            i,
                                            i_pSegment->OFFSET,
                                            i_pSegment->LAYER + 1);

                  if ((l_pSegment->SIGNAL_INDEX == WSEGMENT_FREE) ||
                      (l_pSegment->SIGNAL_INDEX == i_pSegment->SIGNAL_INDEX))
                    {
                       addVirtualConnector (i_pVirConList,
                                            createVirtualConnector (i,
                                                                    i_pSegment->
                                                                    OFFSET,
                                                                    i_pSegment->
                                                                    LAYER + 1,
                                                                    0, 0));

                    }
               }
          }

        // Connexion par aboutement en ALU 0 ?

        if (i_pSegment->LAYER == 0)
          {
             if (i_pSegment->P_MIN > 0)
               {
                  l_pSegment = getWSegment (i_pGrid,
                                            i_pSegment->P_MIN - 1,
                                            i_pSegment->OFFSET,
                                            i_pSegment->LAYER);

                  if ((l_pSegment->SIGNAL_INDEX == WSEGMENT_FREE) ||
                      (l_pSegment->SIGNAL_INDEX == i_pSegment->SIGNAL_INDEX))
                    {
                       addVirtualConnector (i_pVirConList,
                                            createVirtualConnector
                                            (i_pSegment->P_MIN - 1,
                                             i_pSegment->OFFSET,
                                             i_pSegment->LAYER, 0, 0));
                    }
               }

             if (i_pSegment->P_MAX < i_pGrid->SIZE_H - 1)
               {
                  l_pSegment = getWSegment (i_pGrid,
                                            i_pSegment->P_MAX + 1,
                                            i_pSegment->OFFSET,
                                            i_pSegment->LAYER);

                  if ((l_pSegment->SIGNAL_INDEX == WSEGMENT_FREE) ||
                      (l_pSegment->SIGNAL_INDEX == i_pSegment->SIGNAL_INDEX))
                    {
                       addVirtualConnector (i_pVirConList,
                                            createVirtualConnector
                                            (i_pSegment->P_MAX + 1,
                                             i_pSegment->OFFSET,
                                             i_pSegment->LAYER, 0, 0));
                    }
               }

          }
     }
   else
     {
        for (i = i_pSegment->P_MIN; i <= i_pSegment->P_MAX; i++)
          {
             if (i_pSegment->LAYER > 0)
               {
                  l_pSegment = getWSegment (i_pGrid,
                                            i_pSegment->OFFSET,
                                            i, i_pSegment->LAYER - 1);

                  if ((l_pSegment->SIGNAL_INDEX == WSEGMENT_FREE) ||
                      (l_pSegment->SIGNAL_INDEX == i_pSegment->SIGNAL_INDEX))
                    {
                       addVirtualConnector (i_pVirConList,
                                            createVirtualConnector
                                            (i_pSegment->OFFSET, i,
                                             i_pSegment->LAYER - 1, 0, 0));
                    }
               }
             else if (i_pSegment->LAYER < i_pGrid->NB_OF_LAYERS - 1)
               {
                  l_pSegment = getWSegment (i_pGrid,
                                            i_pSegment->OFFSET,
                                            i, i_pSegment->LAYER + 1);

                  if ((l_pSegment->SIGNAL_INDEX == WSEGMENT_FREE) ||
                      (l_pSegment->SIGNAL_INDEX == i_pSegment->SIGNAL_INDEX))
                    {
                       addVirtualConnector (i_pVirConList,
                                            createVirtualConnector
                                            (i_pSegment->OFFSET, i,
                                             i_pSegment->LAYER + 1, 0, 0));
                    }
               }
          }

        // Connexion par aboutement en ALU 1 ?

        if (i_pSegment->LAYER == 1)
          {
             if (i_pSegment->P_MIN > 0)
               {
                  l_pSegment = getWSegment (i_pGrid,
                                            i_pSegment->OFFSET,
                                            i_pSegment->P_MIN - 1,
                                            i_pSegment->LAYER);

                  if ((l_pSegment->SIGNAL_INDEX == WSEGMENT_FREE) ||
                      (l_pSegment->SIGNAL_INDEX == i_pSegment->SIGNAL_INDEX))
                    {
                       addVirtualConnector (i_pVirConList,
                                            createVirtualConnector
                                            (i_pSegment->OFFSET,
                                             (i_pSegment->P_MIN - 1),
                                             i_pSegment->LAYER, 0, 0));
                    }
               }

             if (i_pSegment->P_MAX < i_pGrid->SIZE_V - 1)
               {
                  l_pSegment = getWSegment (i_pGrid,
                                            i_pSegment->OFFSET,
                                            i_pSegment->P_MAX + 1,
                                            i_pSegment->LAYER);

                  if ((l_pSegment->SIGNAL_INDEX == WSEGMENT_FREE) ||
                      (l_pSegment->SIGNAL_INDEX == i_pSegment->SIGNAL_INDEX))
                    {
                       addVirtualConnector (i_pVirConList,
                                            createVirtualConnector
                                            (i_pSegment->OFFSET,
                                             (i_pSegment->P_MAX + 1),
                                             i_pSegment->LAYER, 0, 0));
                    }
               }
          }
     }
}

void
deleteSegment (ocrRoutingParameters * i_pParam,
               ocrWRoutingGrid * i_pGrid, ocrWSegment * i_pSegment)
{
   ocrWSegment *l_pSegment;
   ocrWSegment *l_pNewSegment;
   ocrNaturalInt i;

//  printf ("delete seg %ld\n", i_pSegment->SIGNAL_INDEX);
   // libration du segment
   i_pSegment->SIGNAL_INDEX = WSEGMENT_FREE;

   // Concatnation avec d'autres segments libres eux aussi !
   if (getWSegDirection (i_pParam, i_pSegment) == ocrHorizontal)
     {
        if (i_pSegment->P_MIN > 0)
          {
             l_pSegment = getWSegment (i_pGrid,
                                       i_pSegment->P_MIN - 1,
                                       i_pSegment->OFFSET, i_pSegment->LAYER);

             if (l_pSegment->SIGNAL_INDEX == WSEGMENT_FREE)
               {
//            puts ("1");
                  l_pNewSegment = createWSegment (i_pSegment->OFFSET,
                                                  i_pSegment->LAYER,
                                                  l_pSegment->P_MIN,
                                                  i_pSegment->P_MAX,
                                                  WSEGMENT_FREE);

                  for (i = l_pSegment->P_MIN; i <= i_pSegment->P_MAX; i++)
                     setWGrid (i_pGrid,
                               l_pNewSegment,
                               i, i_pSegment->OFFSET, i_pSegment->LAYER);
/*
   printf ("index --> %ld\n",
   getWSegment (i_pGrid,
   690 / 5,
   220 / 5,
   0)->SIGNAL_INDEX);
 */
                  i_pSegment = l_pNewSegment;
               }
          }

        if (i_pSegment->P_MAX < i_pGrid->SIZE_H - 1)
          {
             l_pSegment = getWSegment (i_pGrid,
                                       i_pSegment->P_MAX + 1,
                                       i_pSegment->OFFSET, i_pSegment->LAYER);

             if (l_pSegment->SIGNAL_INDEX == WSEGMENT_FREE)
               {
//            puts ("2");
                  //            dumpSeg (l_pSegment);
                  l_pNewSegment = createWSegment (i_pSegment->OFFSET,
                                                  i_pSegment->LAYER,
                                                  i_pSegment->P_MIN,
                                                  l_pSegment->P_MAX,
                                                  WSEGMENT_FREE);

                  for (i = i_pSegment->P_MIN; i <= l_pSegment->P_MAX; i++)
                     setWGrid (i_pGrid,
                               l_pNewSegment,
                               i, i_pSegment->OFFSET, i_pSegment->LAYER);

                  i_pSegment = l_pNewSegment;
               }
          }
     }
   else
     {
        if (i_pSegment->P_MIN > 0)
          {
             l_pSegment = getWSegment (i_pGrid,
                                       i_pSegment->OFFSET,
                                       i_pSegment->P_MIN - 1,
                                       i_pSegment->LAYER);

             if (l_pSegment->SIGNAL_INDEX == WSEGMENT_FREE)
               {
                  l_pNewSegment = createWSegment (i_pSegment->OFFSET,
                                                  i_pSegment->LAYER,
                                                  l_pSegment->P_MIN,
                                                  i_pSegment->P_MAX,
                                                  WSEGMENT_FREE);

                  for (i = l_pSegment->P_MIN; i <= i_pSegment->P_MAX; i++)
                     setWGrid (i_pGrid,
                               l_pNewSegment,
                               i_pSegment->OFFSET, i, i_pSegment->LAYER);

                  i_pSegment = l_pNewSegment;
               }
          }

        if (i_pSegment->P_MAX < i_pGrid->SIZE_H - 1)
          {
             l_pSegment = getWSegment (i_pGrid,
                                       i_pSegment->OFFSET,
                                       i_pSegment->P_MAX + 1,
                                       i_pSegment->LAYER);

             if (l_pSegment->SIGNAL_INDEX == WSEGMENT_FREE)
               {
                  l_pNewSegment = createWSegment (i_pSegment->OFFSET,
                                                  i_pSegment->LAYER,
                                                  i_pSegment->P_MIN,
                                                  l_pSegment->P_MAX,
                                                  WSEGMENT_FREE);

                  for (i = i_pSegment->P_MIN; i <= l_pSegment->P_MAX; i++)
                     setWGrid (i_pGrid,
                               l_pNewSegment,
                               i_pSegment->OFFSET, i, i_pSegment->LAYER);
               }
          }
     }
/*
   printf ("D index --> %ld\n",
   getWSegment (i_pGrid,
   690 / 5,
   220 / 5,
   0)->SIGNAL_INDEX);
 */
}

void
deleteEquipotentielle (ocrRoutingParameters * i_pParam,
                       ocrWRoutingGrid * i_pGrid, ocrSignal * i_pSignal)
{
   ocrVirtualConnector *l_pVirCon;
   ocrConnector *l_pCon;
   ocrWSegment *l_pSegment;

   // mise  jour de la grille de routage
   for (l_pSegment = i_pSignal->SEGMENT;
        l_pSegment; l_pSegment = l_pSegment->NEXT)
      deleteSegment (i_pParam, i_pGrid, l_pSegment);

   // Suppression des SEGMENTS & VIA associs
   //  i_pSignal->SEGMENT = NULL;
   i_pSignal->VIA = NULL;

   // Suppression des TAGS
   for (l_pCon = i_pSignal->CON_LIST; l_pCon; l_pCon = l_pCon->NEXT)
     {
        l_pCon->CON = NULL;
        for (l_pVirCon = l_pCon->VIR_CON_LIST;
             l_pVirCon; l_pVirCon = (ocrVirtualConnector *) l_pVirCon->NEXT)
           l_pVirCon->TAG = 0;
     }
}

void
createEquipotentielle (ocrRoutingParameters * i_pParam,
                       ocrWRoutingGrid * i_pGrid,
                       ocrSignal * i_pSignal,
                       ocrVirtualConnector ** i_pVirConList)
{
   ocrWSegment *l_pSegment;

   for (l_pSegment = i_pSignal->SEGMENT;
        l_pSegment; l_pSegment = l_pSegment->NEXT)
      addSegmentToEqui (i_pParam, i_pGrid, l_pSegment, i_pVirConList);
}

#define DELTA 	1
#define COEF	1.3
void
makeExtEquipotentielle (ocrRoutingParameters * i_pParam,
                        ocrWRoutingGrid * i_pGrid,
                        ocrWindow * i_pWindow, ocrConnector * i_pCon)
{
   ocrNaturalInt l_uOffset = 3;
   float l_uDelta = 3.0;
   //ocrNaturalInt l_uDelta = 3;
   ocrVirtualConnector *l_pVirConList = NULL;
   ocrVirtualConnector *l_pVirCon;
   float i;
   //ocrNaturalInt i;

   // Si le connecteur est li, sa position est dtermine.
   if (IS_MARK_AS_LINKED (i_pCon))
     {
        if (!i_pCon->CON)
           puts ("ERROR");
        return;
     }

   // si besoin est !
   if (i_pCon->VIR_CON_LIST)
     {
        deleteVirtualConnectorList (i_pCon->VIR_CON_LIST);
        i_pCon->VIR_CON_LIST = NULL;
        i_pCon->CON = NULL;
     }

   // face SOUTH
   if (i_pCon->FACE & OCR_FACE_SOUTH)
     {
#if DELTA
        if (i_pWindow->NB_SIG_FACE[OCR_FACE_SOUTH] != 0)
           l_uDelta = ((float)(i_pWindow->XMAX - i_pWindow->XMIN)) / COEF /
              i_pWindow->NB_SIG_FACE[OCR_FACE_SOUTH];
        else
           l_uDelta = 2.0;
        if (l_uDelta > 2.0)
           l_uDelta = 2.0;
#endif
   // display (LEVEL, VERBOSE, "S %ld : %ld\n", i_pWindow->NB_SIG_FACE[OCR_FACE_SOUTH], l_uDelta);

        for (i = l_uOffset; i < i_pGrid->SIZE_H - l_uOffset; i += l_uDelta)
          {
             if (IS_MARK_AS_FACE_CON (i_pCon))
                l_pVirCon = createVirtualConnector (i, 0, 1, 0, SOUTH);
             else
                l_pVirCon = createVirtualConnector (i, 0, 0, 0, SOUTH);

             if (isFreePoint (i_pGrid, l_pVirCon))
               {
                  (ocrVirtualConnector *) l_pVirCon->NEXT = l_pVirConList;
                  l_pVirConList = l_pVirCon;
               }
          }
     }

   // face NORTH
   if (i_pCon->FACE & OCR_FACE_NORTH)
     {
#if DELTA
        if (i_pWindow->NB_SIG_FACE[OCR_FACE_NORTH] != 0)
           l_uDelta = ((i_pWindow->XMAX - i_pWindow->XMIN)) / COEF /
              i_pWindow->NB_SIG_FACE[OCR_FACE_NORTH];
        else
           l_uDelta = 2.0;
        if (l_uDelta > 2.0)
           l_uDelta = 2.0;
#endif

//    display (LEVEL, VERBOSE, "N %ld : %ld\n", i_pWindow->NB_SIG_FACE[OCR_FACE_NORTH], l_uDelta);

        for (i = l_uOffset; i < i_pGrid->SIZE_H - l_uOffset; i += l_uDelta)
          {
             if (IS_MARK_AS_FACE_CON (i_pCon))
                l_pVirCon = createVirtualConnector (i,
                                                    (i_pGrid->SIZE_V - 1),
                                                    1, 0, NORTH);
             else
                l_pVirCon = createVirtualConnector (i,
                                                    (i_pGrid->SIZE_V - 1),
                                                    0, 0, NORTH);

             if (isFreePoint (i_pGrid, l_pVirCon))
               {
                  (ocrVirtualConnector *) l_pVirCon->NEXT = l_pVirConList;
                  l_pVirConList = l_pVirCon;
               }
          }
     }

   // face EAST
   if (i_pCon->FACE & OCR_FACE_EAST)
     {
#if DELTA
        if (i_pWindow->NB_SIG_FACE[OCR_FACE_EAST] != 0)
           l_uDelta = ((i_pWindow->YMAX - i_pWindow->YMIN)) / COEF /
              i_pWindow->NB_SIG_FACE[OCR_FACE_EAST];
        else
           l_uDelta = 2.0;
        if (l_uDelta > 2.0)
           l_uDelta = 2.0;
#endif

  //  display (LEVEL, VERBOSE, "E %ld : %ld\n", i_pWindow->NB_SIG_FACE[OCR_FACE_EAST], l_uDelta);

        for (i = l_uOffset; i < i_pGrid->SIZE_V - l_uOffset; i += l_uDelta)
          {
             l_pVirCon = createVirtualConnector (
                                                 (i_pGrid->SIZE_H - 1),
                                                 i, 0, 0, EAST);
             if (isFreePoint (i_pGrid, l_pVirCon))
               {
                  (ocrVirtualConnector *) l_pVirCon->NEXT = l_pVirConList;
                  l_pVirConList = l_pVirCon;
               }
          }
     }

   // face WEST
   if (i_pCon->FACE & OCR_FACE_WEST)
     {
#if DELTA
        if (i_pWindow->NB_SIG_FACE[OCR_FACE_WEST] != 0)
           l_uDelta = ((i_pWindow->YMAX - i_pWindow->YMIN)) / COEF /
              i_pWindow->NB_SIG_FACE[OCR_FACE_WEST];
        else
           l_uDelta = 2.0;
        if (l_uDelta > 2.0)
           l_uDelta = 2.0;
#endif

//    display (LEVEL, VERBOSE, "W %ld : %ld\n", i_pWindow->NB_SIG_FACE[OCR_FACE_WEST], l_uDelta);

        for (i = l_uOffset; i < i_pGrid->SIZE_V - l_uOffset; i += l_uDelta)
          {
             l_pVirCon = createVirtualConnector (0, i, 0, 0, WEST);
             if (isFreePoint (i_pGrid, l_pVirCon))
               {
                  (ocrVirtualConnector *) l_pVirCon->NEXT = l_pVirConList;
                  l_pVirConList = l_pVirCon;
               }
          }
     }

   i_pCon->VIR_CON_LIST = l_pVirConList;
}

void
addVirConToEqui (ocrRoutingParameters * i_pParam,
                 ocrWRoutingGrid * i_pGrid,
                 ocrSignal * i_pSignal, ocrVirtualConnector ** i_pVirConList)
{
   ocrConnector *l_pCon;
   ocrVirtualConnector *l_pVirCon;
   ocrVirtualConnector *l_pVia;

   for (l_pCon = i_pSignal->CON_LIST;
        l_pCon && l_pCon->CON; l_pCon = l_pCon->NEXT)
      if (l_pCon->INTEXT == INTERNAL)
        {
           for (l_pVirCon = l_pCon->VIR_CON_LIST;
                l_pVirCon;
                l_pVirCon = (ocrVirtualConnector *) l_pVirCon->NEXT)
              if (l_pVirCon != l_pCon->CON)
                {

                   l_pVia = createVirtualConnector (l_pVirCon->X,
                                                    l_pVirCon->Y,
                                                    l_pVirCon->Z, 0, 0);
                   l_pVia->DIST = 1;
                   if (isFreePoint (i_pGrid, l_pVia))
                      addVirtualConnector (i_pVirConList, l_pVia);
                }
        }
}


ocrVirtualConnector *
makeEquipotentielle (ocrRoutingParameters * i_pParam,
                     ocrWRoutingGrid * i_pGrid, ocrSignal * i_pSignal)
{
   ocrVirtualConnector *l_pVirCon = NULL;

   // Destruction de la liste si besoin est !
   //  deleteVirtualConnectorList (g_pVirConList);
   //  g_uIndexVirCon = 0;
   //  g_pVirConList = NULL;

   createEquipotentielle (i_pParam, i_pGrid, i_pSignal, &l_pVirCon);

//  addVirConToEqui (i_pParam, i_pGrid, i_pSignal, &l_pVirCon);

   return l_pVirCon;

}

ocrNaturalInt
findPathNPoints (ocrRoutingParameters * i_pParam,
                 ocrWRoutingGrid * i_pGrid,
                 ocrSignal * i_pSignal, ocrWindow * i_pWindow)
{
   ocrConnector *l_pCon;
   ocrConnector l_NewCon;
   ocrNaturalShort l_bOk;
   ocrNaturalInt l_uLength;
   ocrNaturalInt l_uLengthTotal = 0;
   ocrVirtualConnector *l_pVia;
   ocrVirtualConnector *l_pViaList = i_pSignal->VIA;

   l_pCon = i_pSignal->CON_LIST;

   // Cration des connecteurs externes 
   if (i_pSignal->CON_LIST->INTEXT == EXTERNAL)
      makeExtEquipotentielle (i_pParam, i_pGrid, i_pWindow, l_pCon);

   if (i_pSignal->CON_LIST->NEXT->INTEXT == EXTERNAL)
      makeExtEquipotentielle (i_pParam, i_pGrid, i_pWindow, l_pCon->NEXT);
   do
     {
#if 0
        if (i_pSignal->INDEX == 1)
          {
             dumpConList (l_pCon, stdout);
             puts ("---");
          }
#endif

        // Choix des 2 premiers connecteurs
        l_bOk = chooseInternalConnector (i_pGrid, l_pCon, l_pCon->NEXT);

        if (l_bOk != OCR_OK)
          {
             display (LEVEL, DEBUG, "%s\n", "Il n'y a plus de connecteurs !");
             display (LEVEL, DEBUG, "Impossible de router %ld\n",
                      i_pSignal->INDEX);
             return OCRNATURALINT_MAX;
          }

        display (LEVEL, DEBUG, "(%ld,%ld,%d) -> (%ld,%ld,%d)\n",
                 l_pCon->CON->X / 1 * SCALE_X,
                 l_pCon->CON->Y / 1 * SCALE_X,
                 l_pCon->CON->Z / 1 * SCALE_X,
                 l_pCon->NEXT->CON->X / 1 * SCALE_X,
                 l_pCon->NEXT->CON->Y / 1 * SCALE_X,
                 l_pCon->NEXT->CON->Z / 1 * SCALE_X);

        l_uLength = FINDPATH (i_pParam, i_pGrid,
                              l_pCon->CON->X,
                              l_pCon->CON->Y,
                              l_pCon->CON->Z,
                              l_pCon->NEXT->CON->X,
                              l_pCon->NEXT->CON->Y,
                              l_pCon->NEXT->CON->Z,
                              i_pSignal->INDEX, i_pSignal);
     }
   while (l_uLength == OCRNATURALINT_MAX);

   l_uLengthTotal += l_uLength;

   // ajout de 2 VIAs
   if (l_pCon->INTEXT == INTERNAL)
     {
        l_pVia = createVirtualConnector (l_pCon->CON->X,
                                         l_pCon->CON->Y, 0, 0, 0);
        addVirtualConnector (&l_pViaList, l_pVia);
     }

   if (l_pCon->NEXT->INTEXT == INTERNAL)
     {
        l_pVia = createVirtualConnector (l_pCon->NEXT->CON->X,
                                         l_pCon->NEXT->CON->Y, 0, 0, 0);
        addVirtualConnector (&l_pViaList, l_pVia);
     }

   l_pCon = l_pCon->NEXT;

   while (l_pCon->NEXT != NULL)
     {
        ocrVirtualConnector *l_pVirCon;

//  puts("OK");
        //    if (i_pSignal->INDEX == 598)
        //      dumpSegList (i_pSignal->SEGMENT, stdout);

        l_pVirCon = makeEquipotentielle (i_pParam, i_pGrid, i_pSignal);
//    if (i_pSignal->INDEX == 598)
        //      dumpVirConList (l_pVirCon, stdout);
        l_NewCon.VIR_CON_LIST = l_pVirCon;
        l_NewCon.CON = NULL;
//    puts ("OK");

        do
          {
             // Cration des connecteurs virtuels externes 
             // si le connecteur est EXTERNE
             if (l_pCon->NEXT->INTEXT == EXTERNAL)
                makeExtEquipotentielle (i_pParam, i_pGrid, i_pWindow,
                                        l_pCon->NEXT);

             // Recherche d'un point de contact
             l_bOk = 0;

             for (l_pVirCon = l_pCon->NEXT->VIR_CON_LIST;
                  l_pVirCon && !l_bOk;
                  l_pVirCon = (ocrVirtualConnector *) l_pVirCon->NEXT)
               {
                  if (getWSegment (i_pGrid,
                                   l_pVirCon->X,
                                   l_pVirCon->Y,
                                   l_pVirCon->Z)->SIGNAL_INDEX
                      == i_pSignal->INDEX)
                    {
                       ocrVirtualConnector *l_pVia;

                       l_bOk = 1;
                       l_pCon->NEXT->CON = l_pVirCon;
                       l_NewCon.CON = l_pVirCon;
                       l_uLength = 0;

                       // ajout d'un VIA
                       l_pVia = createVirtualConnector (l_pVirCon->X,
                                                        l_pVirCon->Y,
                                                        l_pVirCon->Z, 0, 0);
                       addVirtualConnector (&i_pSignal->VIA, l_pVia);

#ifdef OCRSTAT
                       puts ("Contact");
#endif
                    }
               }

             if (!l_bOk)
               {
                  //    puts ("ICI");
                  // Choix de 2 autres connecteurs
                  l_bOk = chooseInternalConnector (i_pGrid,
                                                   &l_NewCon, l_pCon->NEXT);
                  //  puts ("LA");
                  if (l_bOk != OCR_OK)
                    {
                       display (LEVEL, DEBUG, "%s\n",
                                "Il n'y a plus de connecteurs !");
                       display (LEVEL, DEBUG, "Impossible de router %ld\n",
                                i_pSignal->INDEX);
                       return OCRNATURALINT_MAX;
                    }

                  display (LEVEL, DEBUG, "(%ld,%ld,%d) -> (%ld,%ld,%d)\n",
                           l_NewCon.CON->X / 1 * SCALE_X,
                           l_NewCon.CON->Y / 1 * SCALE_X,
                           l_NewCon.CON->Z,
                           l_pCon->NEXT->CON->X / 1 * SCALE_X,
                           l_pCon->NEXT->CON->Y / 1 * SCALE_X,
									l_pCon->NEXT->CON->Z / 1 * SCALE_X);

                  l_uLength = FINDPATH (i_pParam, i_pGrid,
                                        l_NewCon.CON->X,
                                        l_NewCon.CON->Y,
                                        l_NewCon.CON->Z,
                                        l_pCon->NEXT->CON->X,
                                        l_pCon->NEXT->CON->Y,
                                        l_pCon->NEXT->CON->Z,
                                        i_pSignal->INDEX, i_pSignal);
               }
          }
        while (l_uLength == OCRNATURALINT_MAX);

        // ajout de 2 VIAs
        if (l_pCon->NEXT->INTEXT == INTERNAL)
          {
             l_pVia = createVirtualConnector (l_pCon->NEXT->CON->X,
                                              l_pCon->NEXT->CON->Y, 0, 0, 0);
             addVirtualConnector (&l_pViaList, l_pVia);
          }

        if (l_NewCon.CON->DIST == 1)
          {
             l_pVia = createVirtualConnector (l_NewCon.CON->X,
                                              l_NewCon.CON->Y, 0, 0, 0);
             addVirtualConnector (&l_pViaList, l_pVia);
          }


        unifyPoint (i_pGrid, i_pParam,
                    i_pSignal,
                    l_NewCon.CON->X, l_NewCon.CON->Y, l_NewCon.CON->Z);

        deleteVirtualConnectorList (l_NewCon.VIR_CON_LIST);
        l_pCon = l_pCon->NEXT;
     }
   i_pSignal->VIA = l_pViaList;
   return l_uLengthTotal;
}
