/*
   ### -------------------------------------------------- ### 
   $Author: hcl $
   $Date: 2001/09/26 14:27:56 $
   $Log: ocrConnectorUtil.c,v $
   Revision 1.1  2001/09/26 14:27:56  hcl
   premier commit....


   ### -------------------------------------------------- ###
 */

#include <stdlib.h>
#include <string.h>
#include MUT_H
#include MLO_H
#include MLU_H
#include MPH_H
#include MPU_H
#include "ocr.h"
#include "ocrUtil.h"
#include "ocrWRoutingDataBase.h"
#include "ocrWindow.h"
#include "ocrPath.h"
#include "display.h"

#include "ocrConnectorUtil.h"

static char *res_id = "$Id: ocrConnectorUtil.c,v 1.1 2001/09/26 14:27:56 hcl Exp $";

extern ocrOption *g_pOption;

#define LEVEL (g_pOption->LEVEL)

#define MAX_HT 500
#define PITCH   5

ocrNaturalInt
distBetween2VirCon (ocrVirtualConnector * l_pVirCon1,
                    ocrVirtualConnector * l_pVirCon2)
{
  return ABSDIFF (l_pVirCon1->X, l_pVirCon2->X) +
    ABSDIFF (l_pVirCon1->Y, l_pVirCon2->Y);
}


/**  XXX HCl 
*
*  protection des connecteurs qui n'ont plus qu'un seul
*  connecteur virtuel libre
*
**/

//void
//connectorProtect (ocrConnector * i_pCon)
//
//{
//  ocrVirtualConnector *l_pVirConList;
//
//  for (l_pCon = i_pCon ;
//       l_pCon ; l_pCon = l_pCon->NEXT)
//    {
//       if (l_pCon)
//
//    }
//}
//




/**
 * supprime le connecteur virtuel i_pConVir de 
 * la liste io_pVirConList
**/
void
deleteConVirInConVirList (ocrVirtualConnector ** io_VirConList,
                          ocrVirtualConnector * i_pConVir)
{
  ocrVirtualConnector *l_pVirConList;
  ocrVirtualConnector *l_pVirConListOld = NULL;

  for (l_pVirConList = *io_VirConList;
       l_pVirConList; l_pVirConList = l_pVirConList->NEXT)
    {
      if (l_pVirConList == i_pConVir)
        {
          if (l_pVirConListOld == NULL)
            {
              *io_VirConList = l_pVirConList->NEXT;
            }
          else
            {
              l_pVirConListOld->NEXT = l_pVirConList->NEXT;
            }
        }
      l_pVirConListOld = l_pVirConList;
    }
}

/**
 * segment HORIZONTAL
**/
ocrNaturalInt
isFreeLine (ocrWRoutingGrid * i_pGrid,
            ocrVirtualConnector * l_pVirCon1,
            ocrVirtualConnector * l_pVirCon2)
{
  ocrWSegment *l_pSegment;
  ocrWSegment *l_pSegment2;

  l_pSegment = getWSegment (i_pGrid, l_pVirCon1->X /*/ SCALE_X / PITCH */ ,
                            l_pVirCon1->Y /*/ SCALE_X / PITCH */ ,
                            0);

  l_pSegment2 = getWSegment (i_pGrid, l_pVirCon2->X /*/ SCALE_X / PITCH */ ,
                             l_pVirCon2->Y /*/ SCALE_X / PITCH */ ,
                             0);

  if ((l_pSegment == l_pSegment2) &&
      (l_pSegment->SIGNAL_INDEX == WSEGMENT_FREE))
    {
      return 1;
    }

  return 0;
}

ocrNaturalInt
isFreePoint (ocrWRoutingGrid * i_pGrid, ocrVirtualConnector * l_pVirCon)
{
  return (getWSegment (i_pGrid, l_pVirCon->X /* / SCALE_X / PITCH */ ,
                       l_pVirCon->Y /* / SCALE_X / PITCH */ ,
                       l_pVirCon->Z)->SIGNAL_INDEX == WSEGMENT_FREE);
}

/**
 * cration d'un table de hash
 * correspondance : nom de l'instance <-> ptr sur l'instance
**/
void
createHashTable (ocrRoutingDataBase * i_pDataBase, phfig_list * i_pPhFig)
{
  phins_list *l_pInst;

  // Init Tables de HASH
  i_pDataBase->HTABLE = addht (MAX_HT);
  display (LEVEL, VERBOSE, "%s\n", "Init HashTable ...");

  // parcours des instances physiques
  // sauvegarde des pointeurs dans la table de Hash

  for (l_pInst = i_pPhFig->PHINS; l_pInst; l_pInst = l_pInst->NEXT)
    {
      addhtitem (i_pDataBase->HTABLE,
                 (void *) l_pInst->INSNAME, (int) (l_pInst));
    }

  display (LEVEL, VERBOSE, "%s\n", "HashTable OK ...");
}

/**
 * suppression de la table de hash
**/
void
deleteHashTable (ocrRoutingDataBase * i_pDataBase)
{
  delht (i_pDataBase->HTABLE);
  i_pDataBase->HTABLE = NULL;
  display (LEVEL, VERBOSE, "%s\n", "Delete HashTable ...");
}

/**
 * renvoie les coordonnes absolue du connecteur en tenant
 * compte des transformations de l'instance
**/
void
getPhConCoord (phins_list * i_pPhIns,
               phfig_list * i_pPhModel,
               phref_list * i_pPhRef,
               ocrNaturalInt * o_uXAbsCon, ocrNaturalInt * o_uYAbsCon)
{
  switch (i_pPhIns->TRANSF)
    {
    case NOSYM:
      {
        *o_uXAbsCon = i_pPhIns->XINS + i_pPhRef->XREF;
        *o_uYAbsCon = i_pPhIns->YINS + i_pPhRef->YREF;
        break;
      }
    case SYM_Y:
      {
        *o_uXAbsCon = i_pPhIns->XINS + i_pPhRef->XREF;
        *o_uYAbsCon = i_pPhIns->YINS + i_pPhModel->YAB2 - i_pPhRef->YREF;
        break;
      }
    case SYM_X:
      {
        *o_uXAbsCon = i_pPhIns->XINS + i_pPhModel->XAB2 - i_pPhRef->XREF;
        *o_uYAbsCon = i_pPhIns->YINS + i_pPhRef->YREF;
        break;
      }
    case SYMXY:
      {
        *o_uXAbsCon = i_pPhIns->XINS + i_pPhModel->XAB2 - i_pPhRef->XREF;
        *o_uYAbsCon = i_pPhIns->YINS + i_pPhModel->YAB2 - i_pPhRef->YREF;
        break;
      }
    default:
      {
        puts ("Error getPhConCoord");
        exit (1);
      }
    }
}

ocrNaturalShort
chooseInternalConnectorLine (ocrWRoutingGrid * i_pGrid,
                             ocrConnector * i_pCon, ocrConnector * i_pCon2)
{
  ocrVirtualConnector *l_pVirCon;
  ocrVirtualConnector *l_pVirCon2;
  ocrNaturalShort l_bOk = 0;

  i_pCon->CON = NULL;
  i_pCon2->CON = NULL;

  // recherche de connecteurs virtuels sur une meme range
  // non utilise des 2 instances physiques
  for (l_pVirCon = i_pCon->VIR_CON_LIST;
       l_pVirCon && !l_bOk;
       l_pVirCon = (ocrVirtualConnector *) l_pVirCon->NEXT)
    {
      for (l_pVirCon2 = i_pCon2->VIR_CON_LIST;
           l_pVirCon2 && !l_bOk;
           l_pVirCon2 = (ocrVirtualConnector *) l_pVirCon2->NEXT)
        {
          if ((l_pVirCon2->Y == l_pVirCon->Y) &&
              (isFreeLine (i_pGrid, l_pVirCon, l_pVirCon2)))
            {
              if ((l_pVirCon2->TAG == 0) && (l_pVirCon->TAG == 0))
                {
                  l_bOk = 1;
                  i_pCon->CON = l_pVirCon;
                  i_pCon2->CON = l_pVirCon2;

                }
            }
        }
    }

  // Echec, les deux connecteurs ne peuvent pas etre
  // sur la meme ligne. On recherche les deux connecteurs les
  // plus proches et disponibles ...

  if (!i_pCon->CON)
    {
      ocrNaturalInt l_uDistMin = OCRNATURALINT_MAX;
      ocrNaturalInt l_uDist;

      for (l_pVirCon = i_pCon->VIR_CON_LIST;
           l_pVirCon; l_pVirCon = (ocrVirtualConnector *) l_pVirCon->NEXT)
        {
          if ((isFreePoint (i_pGrid, l_pVirCon)) && (l_pVirCon->TAG == 0))
            {
              for (l_pVirCon2 = i_pCon2->VIR_CON_LIST;
                   l_pVirCon2;
                   l_pVirCon2 = (ocrVirtualConnector *) l_pVirCon2->NEXT)
                {

                  /*
                     if ((isFreePoint (i_pGrid, l_pVirCon)) &&
                     (isFreePoint (i_pGrid, l_pVirCon2)))
                     {
                     if ((l_pVirCon2->TAG == 0) &&
                     (l_pVirCon->TAG == 0))
                   */

                  if ((isFreePoint (i_pGrid, l_pVirCon2)) &&
                      (l_pVirCon2->TAG == 0))
                    {
                      l_uDist = distBetween2VirCon (l_pVirCon, l_pVirCon2);

                      if (l_uDist < l_uDistMin)
                        {
                          l_uDistMin = l_uDist;
                          i_pCon->CON = l_pVirCon;
                          i_pCon2->CON = l_pVirCon2;
                        }
                    }
//                else
                  //                  printf (".");

                }
            }
        }
    }

  if (i_pCon->CON != NULL)
    {
      i_pCon->CON->TAG = 1;
      i_pCon2->CON->TAG = 1;
    }

  return (i_pCon->CON != NULL);
}

/**
 * Dtermine si un connecteur possde tous sauf un de ses connecteurs
 * virtuels de pris. (Urgent  router)
 *
 * retourne 1 : OUI, 0 : NON.
**/
ocrNaturalInt
isCriticalConnector (ocrWRoutingGrid * i_pGrid, ocrConnector * i_pCon)
{
  ocrVirtualConnector *l_pConVir;
  ocrNaturalInt l_uConLibre = 0;

  for (l_pConVir = i_pCon->VIR_CON_LIST;
       l_pConVir; l_pConVir = (ocrVirtualConnector *) l_pConVir->NEXT)
    {
      if (isFreePoint (i_pGrid, l_pConVir))
        l_uConLibre++;
    }
  return (l_uConLibre <= 2);
}

/**
 * Choisit 1 connecteur dans chacune des listes i_pCon i_pCon2
 *
 * Return
 *  OCR_OK 			: OK
 *  OCR_BAD_CON1 	: si l_uCon = 0
 *  OCR_BAD_CON2 	: si l_uCon2 = 0
**/
ocrNaturalShort
chooseInternalConnector (ocrWRoutingGrid * i_pGrid,
                         ocrConnector * i_pCon, ocrConnector * i_pCon2)
{
  ocrVirtualConnector *l_pVirCon;
  ocrVirtualConnector *l_pVirCon2;
  ocrNaturalInt l_uDistMin = OCRNATURALINT_MAX;
  ocrNaturalInt l_uDist;
  ocrNaturalInt l_uCon = 0;
  ocrNaturalInt l_uCon2 = 0;

  if (!IS_MARK_AS_LINKED (i_pCon))
    i_pCon->CON = NULL;
  if (!IS_MARK_AS_LINKED (i_pCon2))
    i_pCon2->CON = NULL;

  for (l_pVirCon = i_pCon->VIR_CON_LIST;
       l_pVirCon; l_pVirCon = (ocrVirtualConnector *) l_pVirCon->NEXT)
    {
      if ((isFreePoint (i_pGrid, l_pVirCon)) && (l_pVirCon->TAG == 0))
        {
          l_uCon++;
          for (l_pVirCon2 = i_pCon2->VIR_CON_LIST;
               l_pVirCon2;
               l_pVirCon2 = (ocrVirtualConnector *) l_pVirCon2->NEXT)
            {
              if ((isFreePoint (i_pGrid, l_pVirCon2)) &&
                  (l_pVirCon2->TAG == 0))
                {
                  l_uCon2++;
                  l_uDist = distBetween2VirCon (l_pVirCon, l_pVirCon2);

                  if (l_uDist < l_uDistMin)
                    {
                      l_uDistMin = l_uDist;
                      i_pCon->CON = l_pVirCon;
                      i_pCon2->CON = l_pVirCon2;
                    }
                }
//                  else
              //                   printf (".");
            }
        }
    }

  if (i_pCon->CON != NULL)
    i_pCon->CON->TAG = 1;
  if (i_pCon2->CON != NULL)
    i_pCon2->CON->TAG = 1;

//   printf ("con : %ld con2 : %ld\n", l_uCon, l_uCon2);
  if (!l_uCon)
    return OCR_BAD_CON1;
  if (!l_uCon2)
    return OCR_BAD_CON2;
  return OCR_OK;
}

/**
 * Cration des connecteurs de la bd
*/
void
initConnectorList (ocrRoutingDataBase * i_pDataBase,
                   phfig_list * i_pPhFig, lofig_list * i_pLoFig)
{
  ocrNaturalInt l_nNbSig;
  losig_list *l_pLoSig;
  ocrConnector *l_pCon;
  locon_list *l_pLoCon;
  chain_list *l_pChain;
  phfig_list *l_pPhModel;
  phins_list *l_pPhInst;
  phref_list *l_pPhRef;
  ocrNaturalInt l_uNbExternal;

  // Cration d'une table de Hash sur les instances physiques
  createHashTable (i_pDataBase, i_pPhFig);

  l_nNbSig = 0;
  for (l_pLoSig = i_pLoFig->LOSIG; l_pLoSig; l_pLoSig = l_pLoSig->NEXT)
    {
      if ((l_pLoSig->NAMECHAIN->DATA != namealloc ("vss")) &&
          (l_pLoSig->NAMECHAIN->DATA != namealloc ("vdd")))
        {
          l_pChain = getptype (l_pLoSig->USER, (long) LOFIGCHAIN)->DATA;

          // parcours des connecteurs du signal
          while (l_pChain)
            {
              // nouveau connecteur
              l_pLoCon = (locon_list *) l_pChain->DATA;
	      

              // Instance physique du connecteur
              // ROOT est une lofig ou une loins ?
              if (l_pLoCon->ROOT == i_pLoFig)
                {               // lofig

                  l_pCon =
                    createConnector (l_pLoCon->NAME, i_pLoFig->NAME,
                                     OCR_TYPE_PONC, EXTERNAL, 0,	// FACE
                                     0,	// ORDER
                                     0);	// NumFMF

                  addConnector (i_pDataBase->GSIGNAL[l_nNbSig], l_pCon);

#ifdef OCR_DEBUG
	      printf("treating external connector :%s\n", l_pLoCon->NAME);
#endif
                  l_uNbExternal++;
                }
              else              // loins

                {
                  l_pPhInst =
                    (phins_list *) gethtitem (i_pDataBase->HTABLE,
                                              (void *) ((loins_list *)
                                                        l_pLoCon->
                                                        ROOT)->INSNAME);

                  if (l_pPhInst == (phins_list *) EMPTYHT)
                    {
                      printf("ERROR : cannot find the right instance: %s\n !", ((loins_list *)l_pLoCon->ROOT)->INSNAME);
                      exit (1);
                    }

                  // Ajout du connecteur interne
                  l_pCon = createConnector (l_pLoCon->NAME,
                                            ((loins_list *) l_pLoCon->
                                             ROOT)->INSNAME, OCR_TYPE_PONC,
                                            INTERNAL, 0,	// FACE
                                            0,	// ORDER
                                            0);	// NumFMF

                  addConnector (i_pDataBase->GSIGNAL[l_nNbSig], l_pCon);
#ifdef OCR_DEBUG
	      printf("treating internal connector :%s\n", l_pLoCon->NAME);
#endif

                  // rcuprer les coordonnes des connecteurs grace
                  // au nom du model
                  l_pPhModel = getphfig (l_pPhInst->FIGNAME, 'A');

                  // parcours des connecteurs du model ...
                  // ajout de tous les connecteurs virutels ...
                  for (l_pPhRef = l_pPhModel->PHREF;
                       l_pPhRef; l_pPhRef = l_pPhRef->NEXT)
                    {
                      // vrification du nom du connecteur
                      if (instr (l_pPhRef->NAME, l_pLoCon->NAME, (char) 0))
                        {
                          ocrVirtualConnector *l_pVirCon;
                          ocrNaturalInt l_uX, l_uY;

                          // coordonnes Absolue du connecteur par rapport
                          //  l'abutment box
                          getPhConCoord (l_pPhInst,
                                         l_pPhModel, l_pPhRef, &l_uX, &l_uY);

//FIXME: ici, on fait l'hypothese que les connecteurs sont tous en z=0
			  
                          l_pVirCon =
                            createVirtualConnector (l_uX / 500, l_uY / 500, 0,	// Z
                                                    0,	// WIDTH
                                                    0);	// ORIENT

                          addVirtualConnector (&(l_pCon->VIR_CON_LIST),
                                               l_pVirCon);
#ifdef OCR_DEBUG
	      printf("adding virtual connector :%s\n", l_pPhRef->NAME);
#endif
                        }
                    }
                }
              l_pChain = l_pChain->NEXT;
            }
          l_nNbSig++;
        }
    }

  // un petit peu de mnage ...
  deleteHashTable (i_pDataBase);
}
