# include MUT_H
# include LOG_H
# include "beh.h"
# include "bhl.h"
# include "bvl.h"

#define BEH_TIME_IDX 0	/* Index utilise pour la derivee dS/dt	*/
#define BEH_NEXT_IDX 1	/* Delta Index utilise pour la derivee dS/dt	*/

   unsigned char BEH_CIRCUI;

/* ###--------------------------------------------------------------### */
/* function     : beh_nextTimeBdd					*/
/* description  : copy a BDD with shifted (+BEH_NEXT_IDX) var index	*/
/* called func. : initVertexBdd						*/
/* ###--------------------------------------------------------------### */

static pNode beh_nextTimeBdd (pt_bdd)

pNode pt_bdd   ;

  {
  pNode varbdd;

  if (pt_bdd == zero)
    {
    varbdd = zero;
    }
  else if (pt_bdd == one)
    {
    varbdd = one;
    }
  else
    {
    varbdd = initVertexBdd ( pt_bdd->index + BEH_NEXT_IDX,
                             beh_nextTimeBdd (pt_bdd->high),
                             beh_nextTimeBdd (pt_bdd->low) );
    }

  return (varbdd);
  }

/* ###--------------------------------------------------------------### */
/* function     : beh_derivSigByTime					*/
/* description  : derivate a BDD by the time				*/
/* called func. : beh_nextTimeBdd, applyBinBdd				*/
/* ###--------------------------------------------------------------### */

static pNode beh_derivSigByTime (pt_bdd)

pNode pt_bdd   ;

  {
  pNode varbdd;

  varbdd   = beh_nextTimeBdd (pt_bdd);

  return (applyBinBdd (XOR, pt_bdd, varbdd));
  }

/* ###--------------------------------------------------------------### */
/* function     : beh_derivSigByVar					*/
/* description  : derivate a BDD by a variable				*/
/* called func. : constraintBdd, applyBinBdd				*/
/* ###--------------------------------------------------------------### */

static pNode beh_derivSigByVar (pt_bdd, index_var)

pNode pt_bdd   ;
short index_var;

  {
  pNode high  ;
  pNode low   ;
  pNode varbdd;

  varbdd = createNodeTermBdd (index_var);

  high   = constraintBdd (pt_bdd, varbdd);
  low    = constraintBdd (pt_bdd, notBdd(varbdd));

  return (applyBinBdd (XOR,high,low));
  }


/* ###--------------------------------------------------------------### */
/* function	: beh_derivSig						*/
/* description	: derivate a BDD by all variables and by time [option]	*/
/* called func.	: beh_derivSigByVar, beh_derivSigByTime			*/
/* ###--------------------------------------------------------------### */

struct beder *beh_derivSig (pt_bdd, pt_varlist, time, mode)

pNode          pt_bdd      ;
struct chain  *pt_varlist  ;
unsigned int   time        ;
unsigned char  mode        ;

  {
  pNode         pt_node     ;
  struct beder *list_derive = NULL;

  if (mode & BEH_NODE_DERIVBYVAR)
    {
    while (pt_varlist != NULL)
      {
      pt_node     = beh_derivSigByVar (pt_bdd, pt_varlist->DATA);
      list_derive = beh_addbeder (list_derive, pt_node, pt_varlist->DATA, time);

      pt_varlist   = pt_varlist->NEXT;
      }
    }

  if (mode & BEH_NODE_DERIVBYTIME)
    {
    pt_node     = beh_derivSigByTime (pt_bdd);
    list_derive = beh_addbeder (list_derive, pt_node, BEH_TIME_IDX, time);
    }

  return (list_derive);
  }
   
