
/* ###--------------------------------------------------------------### */
/*									*/
/* file		: coc109.h						*/
/* date		: Dec 20 1994						*/
/* version	: v109							*/
/* author	: DUNOYER Julien					*/
/* contents	: defines and structure definitions used in COC library	*/
/*									*/
/* ###--------------------------------------------------------------### */

#ifndef COC_COCDEF
#define COC_COCDEF

	/* ###------------------------------------------------------### */
	/*    defines							*/
	/* ###------------------------------------------------------### */

	/* ###------------------------------------------------------### */
	/*    global variables definition                               */
	/* ###------------------------------------------------------### */

	/* ###------------------------------------------------------### */
	/*    structure definitions					*/
	/* ###------------------------------------------------------### */

typedef struct coxcol
  {
  struct coxcol *NEXT ;
  void          *FUNDAMENTAL ;
  unsigned int   LEVEL;
  };

	/* ###------------------------------------------------------### */
	/*    macros definitions					*/
	/* ###------------------------------------------------------### */

#define COC_ELEMENT_COMPARE( elt1, elt2 )                    \
         (long)((unsigned long)(elt1) - (unsigned long)(elt2))

	/* ###------------------------------------------------------### */
	/*    functions							*/
	/* ###------------------------------------------------------### */

extern unsigned int       coc_ChooseLevel ();

extern struct coxcol     *coc_CreateFundamentalSet ();
extern struct coxcol     *coc_CreateIntersectionSet ();
extern void               coc_UpdateSetLevels ();
extern struct coxcol     *coc_CreateUnionSet ();
extern struct coxcol     *coc_CopySet ();
extern struct coxcol     *coc_GetInSetElement ();
extern struct coxcol     *coc_AddSetElement ();
extern void               coc_FreeSet ();
extern int                coc_SetCompare ();
extern struct chain      *coc_Set2Cst ();
extern struct coxcol     *coc_Levelize ();
extern void               coc_BackPropagate ();
extern void               coc_DividePropagate ();
extern void               coc_DecremPropagate ();
extern struct coxcol     *coc_GetMaxLevelInSet ();


#endif
