
/* ###--------------------------------------------------------------### */
/* file		: scg_inswave.c						*/
/* date		: Aug  5 1997						*/
/* version	: v101							*/
/* author	: Nizar ABDALLAH, Pirouz BARAGAN SABET			*/
/* description	: scheduler						*/
/* ###--------------------------------------------------------------### */

#include <stdio.h>
#include SCG_H

/* ###--------------------------------------------------------------### */
/* function	: scg_inswave						*/
/* description	: insert a new transaction into the scheduler (main	*/
/*		  identifier access)					*/
/* called func.	: scg_rmventry						*/
/* ###--------------------------------------------------------------### */

/* ###--------------------------------------------------------------### */
/* modification	:- Un parametre inert permet de passer le Pulse Reject	*/
/*   22/01/98      Limit et de se preparer ainsi en douceur a VHDL'93.	*/
/*               - Le parametre flags a ete supprime. Il etait inutile	*/
/*                 car on peut lire ces flags dans pt_shtra->FLAGS.	*/
/* ###--------------------------------------------------------------### */

void scg_inswave (pt_shdul, pt_shtra, inert)

struct shdul   *pt_shdul;
struct shtra   *pt_shtra;
unsigned int    inert   ;

  {
  struct shtra *pt_beftra;
  struct shtra *pt_afttra;
  struct shtra *pt_deltra;
  struct shtra *pt_lsttra;
  struct shtra *pt_tmptra;
  struct shwav *pt_shwav ;
  unsigned int  index    ;

  index    = scg_hash (pt_shtra->IDENT);
  pt_shwav = pt_shdul->ITABLE [index];
  
  while ((pt_shwav != NULL) && (pt_shwav->IDENT != pt_shtra->IDENT))
    pt_shwav = pt_shwav->NEXT;

  if (pt_shwav == NULL)
    {
    pt_shwav                 = scg_addshwav (pt_shdul->ITABLE [index],
                                             pt_shtra->IDENT          );
    pt_shdul->ITABLE [index] = pt_shwav;
    }

  pt_lsttra = NULL;
  pt_afttra = pt_shwav->TRANS;

  while ((pt_afttra != NULL) && (pt_afttra->DATE < (pt_shtra->DATE - inert)))
    {
    pt_lsttra = pt_afttra;
    pt_afttra = pt_afttra->WAVE;
    }

  pt_deltra = NULL;

/* ###--------------------------------------------------------------### */
/*        ATTENTION, LA COMPARAISON EST FAITE ICI SUR LES POINTEURS	*/
/* ###--------------------------------------------------------------### */

  while ((pt_afttra != NULL) && (pt_afttra->DATE < pt_shtra->DATE))
    {
    pt_lsttra = pt_afttra;
    if ((pt_afttra->COND != pt_shtra->COND) ||
        (pt_afttra->VALU != pt_shtra->VALU)  )
      pt_deltra = pt_afttra;

    pt_afttra = pt_afttra->WAVE;
    }

  if ((pt_shtra->FLAGS & SCG_TRA_DELAFTER) != 0)
    {
    while (pt_afttra != NULL)
      pt_afttra = scg_rmventry (pt_afttra);
    }
    
  if (pt_lsttra != NULL)
    pt_lsttra->WAVE = pt_shtra;
  else
    pt_shwav->TRANS = pt_shtra;

  pt_shtra->WAVE = pt_afttra;

  if ((pt_deltra != NULL) && ((pt_shtra->FLAGS & SCG_TRA_DELBEFORE) != 0))
    {
    pt_tmptra = pt_shwav->TRANS;
    while (pt_tmptra != pt_deltra)
      pt_tmptra = scg_rmventry (pt_tmptra);

    pt_shwav->TRANS = scg_rmventry (pt_tmptra);
    }
  }
