/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <ctype.h>
#include <string.h>
#include <stdio.h>
#include <genlib.h>

#include IAC_H
#include ICN_H
#include ICU_H

/* some defines :
   for normalisation purposes
   to ease the description */
/* to use the usual system of coordinates */
#define ICONX  30
#define ICONY -30
/* to make homogeneous connector placement */
#define CON_NORTH(d) SAX_NORTH, d, SAX_CENTER, SAX_UP,     SAX_HORIZONTAL
#define CON_SOUTH(d) SAX_SOUTH, d, SAX_CENTER, SAX_DOWN,   SAX_HORIZONTAL
#define CON_WEST(d)  SAX_WEST,  d, SAX_LEFT,   SAX_CENTER, SAX_HORIZONTAL
#define CON_EAST(d)  SAX_EAST,  d, SAX_RIGHT,  SAX_CENTER, SAX_HORIZONTAL
/* globals for the use of the macros */
IconGate_list *icon;
IconComp_list *comp = NULL;
#define ADDICONGATE(name, xm, ym, xi, yi, xl, yl)                    \
        (icon = addicongate(name, (xm) * ICONX, (ym) * ICONY,        \
                             SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL, \
                             (xi) * ICONX, (yi) * ICONY,             \
                             SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL, \
                             (xl) * ICONX, (yl) * ICONY,             \
                             SAX_CENTER, SAX_CENTER, SAX_HORIZONTAL))
#define ADDICONCON(name, xc, yc, face, dir) \
        do {                           \
            switch (face) { \
               case SAX_NORTH: \
                            addiconcon(icon, name, (xc) * ICONX, (yc) * ICONY, \
                             CON_NORTH(dir), \
                             (xc) * ICONX, ((yc) - 22) * ICONY); \
                  break; \
               case SAX_SOUTH: \
                            addiconcon(icon, name, (xc) * ICONX, (yc) * ICONY, \
                             CON_SOUTH(dir), \
                             (xc) * ICONX, ((yc) + 22) * ICONY); \
                  break; \
               case SAX_EAST: \
                            addiconcon(icon, name, (xc) * ICONX, (yc) * ICONY, \
                                                           CON_EAST(dir), \
                             ((xc) - 22) * ICONX, (yc) * ICONY); \
                  break; \
               case SAX_WEST: \
                            addiconcon(icon, name, (xc) * ICONX, (yc) * ICONY, \
                             CON_WEST(dir), \
                             ((xc) + 22) * ICONX, (yc) * ICONY); \
                  break; \
            } \
         } while (0)
#define ADDICONLINE(x0, y0, x1, y1) \
        addiconline(icon, (x0) * ICONX, (y0) * ICONY, \
                    (x1) * ICONX, (y1) * ICONY)
#define ADDICONSHAPE() do { \
                          addiconshape(icon, comp); \
                          comp = NULL; \
                       } while(0)
#define ADDICONCOMP(type, x, y) \
        (comp = addiconcomp(comp, type, (x) * ICONX, (y) * ICONY))
#define SAVEICON() do { \
                      mbkenv(); \
                      update_icon(icon); \
                      saveicon(icon); \
                   } while(0)


#define rage_t_name ("espcd10")
#define rage_t_mic (1.0) 

#define rage_tc_gate (1670e-6)
#define rage_tc_poly (160e-6)
#define rage_tc_alu1 (160e-6)
#define rage_tc_alu2 (160e-6)

char valeur();
char TRANSF;
int taille, L, C, i, j, bpm, bpm2, X, Y, M, col, tr, un;
char *IDENTIF;

main(argc,argv)
int argc;
char *argv[] ;
{
 int a, c, i, bits, words, factor, uni, tras, lay, net, outl, vhdl, data, icon, wrd, clock;
 char *s;
 char *name, car;

 mbkenv();
 i = present();

 if( argc < 3 ) {
                  printf(
                  "Usage : rage <bits> <words> [-n |-m |-w] [-u] [-t<n>] [-ckup/-ckdown] [-o blockname] [-layout] [-vhdl] [-datasheet] [-icon] [-logicalbox] [-physicalbox] \n");
                  exit(1);
                 }

 for( i=1;i<3;i++)
 for( s = argv[i] ; *s !='\0' ; s++ )
 if( *s < '0' || *s > '9' ){
 if ( i == 1 ) {
                printf("Omitted bits per word \n");
               } 
 else {
       printf("Omitted number of words \n");
      }
 exit( 2 );
 }

 bits = atoi(argv[1]);
 words = atoi(argv[2]);

 factor = uni = tras = lay = net = outl = vhdl = data = icon = clock = 0;
 car = '\0';
 name = &car;
 for(i=3; i<argc ; i++)
 {
  if( strcmp( argv[ i ], "-n" ) == 0) factor = 0;
  else
  if( strcmp( argv[ i ], "-m" ) == 0) factor = 1;
  else
  if( strcmp( argv[ i ], "-w" ) == 0) factor = 2;
  else
  if( strcmp( argv[ i ], "-u" ) == 0) uni = 1;
  else
  if( strcmp( argv[ i ], "-t1" ) == 0) tras = 1;
  else
  if( strcmp( argv[ i ], "-t2" ) == 0) tras = 2;
  else
  if( strcmp( argv[ i ], "-ckup" ) == 0) clock = 1;
  else
  if( strcmp( argv[ i ], "-ckdown" ) == 0) clock = 0;
  else
  if( strcmp( argv[ i ], "-layout" ) == 0) lay = 1;
  else
  if( strcmp( argv[ i ], "-netlist" ) == 0) net = 1;
  else
  if( strcmp( argv[ i ], "-physicalbox" ) == 0) outl = outl+1;
  else
  if( strcmp( argv[ i ], "-logicalbox" ) == 0) outl = outl+10;
  else
  if( strcmp( argv[ i ], "-vhdl" ) == 0) vhdl = 1;
  else
  if( strcmp( argv[ i ], "-datasheet" ) == 0) data = 1;
  else
  if( strcmp( argv[ i ], "-icon" ) == 0) icon = 1;
  else
  if( strcmp( argv[ i ], "-o" ) == 0){
        name = argv[i+1];
        if(*name == '\0'){
             printf(
             "The name must be included after the [-o] option \n"); 
             exit( 3 );
        }
        else i++;
  }
  else
   printf("rage: Unknown Parameter or Option\n");
 }

 if( bits > 128 || bits < 2 ){
                              printf("Number of bits out of range [2-128]\n"); 
                              exit(4);
                             }
 i = bits /2;
 i = i*2;
 if( bits != i ){
                 printf("bits must be even \n");
                 exit(5);
                }
/*
 if( words < 7 || words > 12 ){
                               printf("words out of range [7-12]\n");  
                               exit(6);
                              }
*/
switch(words)
{
 case 128:{
           wrd = 7;
           break;
          }
 case 256:{
           wrd = 8;
           break;
          }
 case 512:{
           wrd = 9;
           break;
          }
 case 1024:{
           wrd = 10;
           break;
          }
 case 2048:{
           wrd = 11;
           break;
          }
 case 4096:{
           wrd = 12;
           break;
          }
 default:{
          if( words < 128 || words > 4096 ){
                                            printf("words out of range [128-4096]\n");
                                           }
          else {
                printf("illegal size: size must be a power of 2[128, 256, .. ,4096]\n");
               }
                                            exit(6);
         }
}

 switch(wrd)
 {
  case 7 :{
           a = 1;
           c = 6;
           break;
          }
  case 8 :{
           switch(factor)
           {
             case 0:{ 
                     a = 1;
                     c = 7;
                     break;
                    }
             default:{ 
                      a = 2;
                      c = 6;
                      break;
                     }
           }
           break;
          }
  case 9 :{
           switch(factor)
           {
             case 0:{ 
                     a = 1;
                     c = 8;
                     break;
                    }
             case 1:{ 
                     a = 2;
                     c = 7;
                     break;
                    }
             default:{ 
                      a = 3;
                      c = 6;
                      break;
                     }
           }
           break;
          }
  case 10:{
           switch(factor)
           {
             case 0:{ 
                     a = 2;
                     c = 8;
                     break;
                    }
             case 1:{ 
                     a = 3;
                     c = 7;
                     break;
                    }
             default:{ 
                      a = 4;
                      c = 6;
                      break;
                     }
           }
           break;
          }
  case 11:{
           switch(factor)
           {
             case 0:{ 
                     a = 3;
                     c = 8;
                     break;
                    }
             default:{ 
                      a = 4;
                      c = 7;
                      break;
                     }
           }
           break;
          }
  case 12:{
           a = 4;
           c = 8;
           break;
          }
  default: break;
 } 

  i = gram(a,bits,c,uni,tras,clock,lay,net,outl,vhdl,data,icon,name); 
  
  exit(0);
}

 
/*   a: correspond a la taille du mux de la RAM  en puiss de 2  */
/*   b: correspond a la taille du mot de la RAM                 */
/*   c: correspond au nombre de lignes de la RAM  en puiss de 2 */
/*                                                              */
/*   d: uni ou bi-dir                                           */
     
     
gram(a,b,c,d,e,ck,f,g,h,r,s,t,name)
int a, b, c, d, e, ck, f, g, h, r, s, t;
char *name;
{
  int i,j,k,l,x,y;
  char  nom[100], *p;
  taille = a+c;
  bpm = b;
  bpm2 = (int) bpm/2;
  L = c;
  C = a;
  tr = e;
  un = d;
  if(*name != '\0')
   sprintf(nom,"%s\0",name);
  else
   sprintf(nom,"mem_%d_%d_%d\0",bpm,L,C);
  
  IDENTIF=nom;
  if((f==1) || (h==1) || (h==11)){ 
      i = bit_col();
      y= Y + 56; 
      x = puiss(C)*18;
      switch(tr)
      {
       case 0 :{ x += 10;
                 break;
               }
       case 1 :{ x += 12;
                 break;
               }
       case 2 :{ x += 15;
                 break;
               }
       default: break;
      }
      x = x * bpm;
      i = decgen(ck);
      x += 421;
      GENLIB_DEF_PHFIG(nom);
      i = genram();
      GENLIB_DEF_AB(-2, 0, 2, 0);
      i = copcon();
      if(((h==1) || (h==11)) && (f==0)) i = outline();
      GENLIB_SAVE_PHFIG();
            }
  if (r==1) i=vhdl(nom,ck);
  if (s==1) i=data(nom,ck);
  if (t==1) i=rage_icon(nom);
  if (h>=10) i=logical(nom);
}
  

genram()
 {
int i,j,k,y;

GENLIB_PLACE(GENLIB_NAME("%s_col",IDENTIF),"rbit_0_0",NOSYM,0,0);
for(i=1; i<bpm2; i++)
GENLIB_PLACE_RIGHT(GENLIB_NAME("%s_col",IDENTIF),GENLIB_NAME("rbit_%d_0",i),NOSYM);

GENLIB_PLACE_RIGHT(GENLIB_NAME("%s_dec",IDENTIF), "decod",NOSYM);

for(i=0; i<bpm2; i++)
GENLIB_PLACE_RIGHT(GENLIB_NAME("%s_col",IDENTIF),GENLIB_NAME("rbit_%d_1",i),SYM_X);
}


decod()
{
 int i, j, k, l, m;

 M = 13;
 m = puiss(L-2);
 for(i=0;i<m;i++)
 {
   GENLIB_PLACE(GENLIB_NAME("dtdcg%d_c",L), GENLIB_NAME("DECG_%d", i), NOSYM, M, Y);
   GENLIB_PLACE_RIGHT("dtcmb_c",GENLIB_NAME("ADR_%d",i),NOSYM);
   GENLIB_PLACE_RIGHT(GENLIB_NAME("dtdcd%d_c",L), GENLIB_NAME("DECD_%d", i), NOSYM);
   Y+=104;
 }
  return(0);
}

puiss(i)
 int i;
{
 if (i==0) return(1);
 else return(2*puiss(i-1));
}
    
data(name,clk)
char *name;
int clk;
{
int t, height, width;
float heightm, widthm;
FILE *out;

out=stdout;
fprintf(out,"Name :  \"%s\" \n\n",name);
fprintf(out,"Function : Static Random Access Memory of ");

t= L+C;
switch(t)
{
 case 7:
 case 8:
 case 9:{ fprintf(out,"%d words of %d bits size\n",puiss(t),bpm);
          break;
        }
 case 10:
 case 11:
 case 12:{ fprintf(out,"%dK-words of %d bits size\n",puiss(t-10),bpm);
          break;
        }
 default:break;
}
if(un==1) fprintf(out,"           with unidirectionnal Datain and Dataout Buses\n\n");
else fprintf(out,"           with bidirectionnal Datain/Dataout Bus\n\n");


fprintf(out,"Technology : \"%s\" \n\n",rage_t_name);

switch(C)
{
 case 1:{ if(un==1) height = 810;
          else height = 868;
          break;
        }
 default:{ height = 670;
           break;
         }
}
height += puiss(L)*26 + 56;

width= puiss(C)*18;

switch(tr)
{
 case 0:{ width +=10;
          break;
        }
 case 1:{ width +=12;
          break;
        }
 case 2:{ width +=15;
          break;
        }
 default:break;
}
width = width * bpm + 421;

widthm = width * rage_t_mic;
heightm = height * rage_t_mic;

fprintf(out, "Dimensions :\n");
fprintf(out, "              Height  Width      Area\n");
fprintf(out, "Lambdas        %5d  %5d%10d\n",
  height, width, height*width);
fprintf(out, "Microns        %5.0f  %5.0f%10.0f\n\n",
  heightm, widthm, heightm*widthm);

fprintf(out, "List of signals connectors :\n");
fprintf(out, "****************************\n\n");
fprintf(out, "  entries :\n");
fprintf(out, "  ---------\n");

fprintf(out, "    adr[%d:0];\n", L+C-1);
fprintf(out, "    ck;\n");
fprintf(out, "    en;\n");
fprintf(out, "    write;\n");
if(un==1) fprintf(out, "    din[%d:0];\n", bpm-1);

fprintf(out, "\n  outputs :\n");
fprintf(out, "  ---------\n");

fprintf(out, "    dout[%d:0];\n", bpm-1);
fprintf(out,"\n\n");
fprintf(out,"Functionnal Timing Diagram\n");
fprintf(out,"**************************\n\n");
if(clk==0)
{
 fprintf(out,"          ___     ___     ___     ___     ___     ___     ___     ___\n");
 fprintf(out,"   ck        \\___/   \\___/   \\___/   \\___/   \\___/   \\___/   \\___/   \\__\n"); 
}
else
{
 fprintf(out,"              ___     ___     ___     ___     ___     ___     ___     __\n");
 fprintf(out,"   ck     ___/   \\___/   \\___/   \\___/   \\___/   \\___/   \\___/   \\___/\n"); 
}
fprintf(out,"          ______________________________                        ________\n");
fprintf(out,"   en                                   \\______________________/\n");
fprintf(out,"          ______ _______ _______ _______ _______________ ________ _______\n");
fprintf(out,"   adr    ______X_______X_______X_______X_______________X________X_______\n");
fprintf(out,"                        _______\n");
fprintf(out,"   write  _____________/       \\________________________________________\n");
if(un==1)
{
 fprintf(out,"           __      __              __                              __\n");
 fprintf(out,"   dout   <__>----<__>------------<__>----------------------------<__>--\n");
 fprintf(out,"                          _____                                         \n");
 fprintf(out,"   din    ---------------<_____>----------------------------------------\n");
}
else
{
 fprintf(out,"           __      __     _____    __                              __\n");
 fprintf(out,"   dinout <__>----<__>---<_____>--<__>----------------------------<__>--\n");
}
}

logical(name)
char *name;
{
 int i;

 GENLIB_DEF_LOFIG(name);

  GENLIB_LOCON(GENLIB_NAME("adr[%d:0]",(L+C-1)),'I',GENLIB_NAME("adr[%d:0]",(L+C-1)));
 if(un==0){
  GENLIB_LOCON(GENLIB_NAME("dout[%d:0]",bpm-1),'X',GENLIB_NAME("dout[%d:0]",bpm-1));
          }
 else {
  GENLIB_LOCON(GENLIB_NAME("dout[%d:0]",bpm-1),'O',GENLIB_NAME("dout[%d:0]",bpm-1));
  GENLIB_LOCON(GENLIB_NAME("din[%d:0]",bpm-1),'I',GENLIB_NAME("din[%d:0]",bpm-1));
      }
  GENLIB_LOCON("ck",'I',"ck");
  GENLIB_LOCON("en",'I',"en");
  GENLIB_LOCON("write",'I',"write");
  GENLIB_LOCON("vdd",'I',"vdd");
  GENLIB_LOCON("vss",'I',"vss");

 GENLIB_SAVE_LOFIG();   
}

bit_col()
{ int i,j,k;
  char TRANS;
  long x;

 GENLIB_DEF_PHFIG(GENLIB_NAME("ibit_%d",C));
 
 switch (C)
  {
    case 1:{
       	    if(un==0) {
                       GENLIB_PLACE("dtio2_c","IO_1", NOSYM, 0, 0);
                       Y = 616;
                      }
       	    else {
                  GENLIB_PLACE("dtio0_c","IO_1", NOSYM, 0, 0);
                  Y = 558;
                 }
            GENLIB_PLACE_TOP("dtio_c","IO_0", NOSYM);
            break;
           }
    case 2:
    case 3:
    case 4:{
       	    if(un==0) GENLIB_PLACE("dtio3_c","IO_0", NOSYM, 0, 0);
       	    else GENLIB_PLACE("dtio4_c","IO_0", NOSYM, 0, 0);
            Y = 418;
            break;
           }
    default: break;
  }


 for(i=0;i<puiss(C-1);i++)
 {
  if(i==0) GENLIB_PLACE("dtmx0_c","MUX0",NOSYM,0,Y);
  else
  if(i==(puiss(C-1)-1)) GENLIB_PLACE_RIGHT("dtmxm_c",GENLIB_NAME("MUX%d",i),NOSYM);
  else
  GENLIB_PLACE_RIGHT("dtmxi_c",GENLIB_NAME("MUX%d",i),NOSYM);
 }


 Y += 134;
 GENLIB_PLACE("dtali1_c", "alim1_0", NOSYM, 0,Y);
 for(i=1;i<puiss(C-1);i++)
 GENLIB_PLACE_RIGHT("dtali1_c", GENLIB_NAME("alim1_%d", i), NOSYM);


 GENLIB_DEF_AB(0,0,0,0);

 for(i=0;i<puiss(C-1);i++)
 {
  GENLIB_PLACE_VIA_REF(GENLIB_NAME("MUX%d",i),GENLIB_NAME("sl%d",2*i),CONT_VIA);
  GENLIB_WIRE1(ALU2,2,GENLIB_NAME("MUX%d",i),GENLIB_NAME("sl%d",2*i),0,GENLIB_NAME("MUX%d",i),"rsel0",0);
  GENLIB_PLACE_VIA_REF(GENLIB_NAME("MUX%d",i),GENLIB_NAME("sl%d",2*i+1),CONT_VIA);
  GENLIB_WIRE1(ALU2,2,GENLIB_NAME("MUX%d",i),GENLIB_NAME("sl%d",2*i+1),0,GENLIB_NAME("MUX%d",i),"rsel1",0);
  for(j=0;j<puiss(C);j++)
  {
   GENLIB_WIRE1(ALU1,1,GENLIB_NAME("MUX%d",i),GENLIB_NAME("sl_1_%d",j),0,GENLIB_NAME("MUX%d",i),GENLIB_NAME("sl_2_%d",j),0);
  }
 }

  for(j=0;j<puiss(C);j++)
  {
   GENLIB_PLACE_CON_REF("MUX0",GENLIB_NAME("sl_2_%d",j),GENLIB_NAME("sel%d",j),ALU1,1,WEST);
   GENLIB_PLACE_CON_REF(GENLIB_NAME("MUX%d",puiss(C-1)-1),GENLIB_NAME("sl_1_%d",j),GENLIB_NAME("sel%d",j),ALU1,1,EAST);
  }



 switch (C)
  {
    case 1:{
       	    GENLIB_COPY_UP_ALL_CON(EAST,"IO_0", NO);
       	    GENLIB_COPY_UP_ALL_CON(WEST,"IO_0", NO);
            if(un==0)
            {
             GENLIB_COPY_UP_CON_FACE(SOUTH,"dout","IO_1","dout");
             GENLIB_COPY_UP_CON_FACE(EAST,"vdd3","IO_1","vdd3");
             GENLIB_COPY_UP_CON_FACE(EAST,"vdd4","IO_1","vdd4");
             GENLIB_COPY_UP_CON_FACE(EAST,"vdd5","IO_1","vdd5");
             GENLIB_COPY_UP_CON_FACE(EAST,"vss3","IO_1","vss3");
             GENLIB_COPY_UP_CON_FACE(EAST,"vss4","IO_1","vss4");
             GENLIB_COPY_UP_CON_FACE(EAST,"vss5","IO_1","vss5");
             GENLIB_COPY_UP_CON_FACE(EAST,"wen","IO_1","wen");
             GENLIB_COPY_UP_CON_FACE(EAST,"ckp","IO_1","ckp2");
             GENLIB_COPY_UP_CON_FACE(EAST,"n_sel","IO_1","n_sel");
             GENLIB_COPY_UP_CON_FACE(EAST,"sel","IO_1","sel");
             GENLIB_COPY_UP_CON_FACE(WEST,"vdd3","IO_1","vdd3");
             GENLIB_COPY_UP_CON_FACE(WEST,"vdd4","IO_1","vdd4");
             GENLIB_COPY_UP_CON_FACE(WEST,"vdd5","IO_1","vdd5");
             GENLIB_COPY_UP_CON_FACE(WEST,"vss3","IO_1","vss3");
             GENLIB_COPY_UP_CON_FACE(WEST,"vss4","IO_1","vss4");
             GENLIB_COPY_UP_CON_FACE(WEST,"vss5","IO_1","vss5");
             GENLIB_COPY_UP_CON_FACE(WEST,"wen","IO_1","wen");
             GENLIB_COPY_UP_CON_FACE(WEST,"ckp","IO_1","ckp2");
             GENLIB_COPY_UP_CON_FACE(WEST,"n_sel","IO_1","n_sel");
             GENLIB_COPY_UP_CON_FACE(WEST,"sel","IO_1","sel");
            }
            else
            {
             GENLIB_COPY_UP_CON_FACE(SOUTH,"dout","IO_1","dout");
             GENLIB_COPY_UP_CON_FACE(SOUTH,"inn","IO_1","inn");
             GENLIB_COPY_UP_CON_FACE(EAST,"vdd3","IO_1","vdd3");
             GENLIB_COPY_UP_CON_FACE(EAST,"vdd4","IO_1","vdd4");
             GENLIB_COPY_UP_CON_FACE(EAST,"vss3","IO_1","vss3");
             GENLIB_COPY_UP_CON_FACE(EAST,"vss4","IO_1","vss4");
             GENLIB_COPY_UP_CON_FACE(EAST,"vss5","IO_1","vss5");
             GENLIB_COPY_UP_CON_FACE(EAST,"wen","IO_1","wen");
             GENLIB_COPY_UP_CON_FACE(EAST,"ckp","IO_1","ckp2");
             GENLIB_COPY_UP_CON_FACE(WEST,"vdd3","IO_1","vdd3");
             GENLIB_COPY_UP_CON_FACE(WEST,"vdd4","IO_1","vdd4");
             GENLIB_COPY_UP_CON_FACE(WEST,"vss3","IO_1","vss3");
             GENLIB_COPY_UP_CON_FACE(WEST,"vss4","IO_1","vss4");
             GENLIB_COPY_UP_CON_FACE(WEST,"vss5","IO_1","vss5");
             GENLIB_COPY_UP_CON_FACE(WEST,"wen","IO_1","wen");
             GENLIB_COPY_UP_CON_FACE(WEST,"ckp","IO_1","ckp2");
            }
            break;
           }
    case 2:
    case 3:
    case 4:{
       	    GENLIB_COPY_UP_ALL_CON(EAST,"IO_0", NO);
       	    GENLIB_COPY_UP_ALL_CON(WEST,"IO_0", NO);
       	    GENLIB_COPY_UP_ALL_CON(SOUTH,"IO_0", NO);
            break;
           }
    default: break;
  }
 for(i=0;i<puiss(C-1);i++)
 {
  for(j=0;j<2;j++)
  {
   GENLIB_COPY_UP_CON_FACE(NORTH,GENLIB_NAME("bit%d",j),GENLIB_NAME("alim1_%d",i),GENLIB_NAME("bit_%d",i*2+j));
   GENLIB_COPY_UP_CON_FACE(NORTH,GENLIB_NAME("n_bit%d",j),GENLIB_NAME("alim1_%d",i),GENLIB_NAME("nbit_%d",i*2+j));
  }
 }
 GENLIB_COPY_UP_CON_FACE(EAST,"vdd",GENLIB_NAME("alim1_%d",puiss(C-1)-1),"vdd");
 GENLIB_COPY_UP_CON_FACE(EAST,"vss",GENLIB_NAME("alim1_%d",puiss(C-1)-1),"vss");
 GENLIB_COPY_UP_CON_FACE(WEST,"vdd","alim1_0","vdd");
 GENLIB_COPY_UP_CON_FACE(WEST,"vss","alim1_0","vss");

 GENLIB_SAVE_PHFIG();

 GENLIB_DEF_PHFIG(GENLIB_NAME("%s_col",IDENTIF));

 GENLIB_PLACE(GENLIB_NAME("ibit_%d",C),"io_bit",0,0,NOSYM);
 
 switch(C)
 {
  case 1:{
          if(un==0) Y=868;
          else Y = 810;
          break;
         }
  case 2:
  case 3:
  case 4:{
          Y = 670;
          break;
         }
  default:break;
 }

 TRANS = NOSYM;
 k = 0;
 for(i=0;i< puiss(L);i++)
 {
  GENLIB_PLACE("dtram_c",GENLIB_NAME("ram_%d_0",i), TRANS,0,Y);
  for(j=1;j<puiss(C);j++)
  GENLIB_PLACE_RIGHT("dtram_c",GENLIB_NAME("ram_%d_%d",i,j),TRANS);
  GENLIB_PLACE_RIGHT(GENLIB_NAME("dttr%d_c",tr),GENLIB_NAME("trans_%d",i),TRANS);
  Y += 26;
  if (k==0) { k=1;
              TRANS = SYM_Y;
            }
  else { k = 0;
         TRANS = NOSYM;
       }
 }

 GENLIB_PLACE("dtpre_c", "prech_0", NOSYM, 0,Y);
 for(i=1;i< puiss(C-1);i++)
 GENLIB_PLACE_RIGHT("dtpre_c", GENLIB_NAME("prech_%d", i), NOSYM);

 GENLIB_DEF_AB(0,0,0,0);
 
 GENLIB_COPY_UP_ALL_CON(EAST,"io_bit",NO);
 GENLIB_COPY_UP_ALL_CON(WEST,"io_bit",NO);
 GENLIB_COPY_UP_ALL_CON(SOUTH,"io_bit",NO);
 for(i=0;i<tr;i++)
 {
  x = GENLIB_GET_REF_X("trans_0",GENLIB_NAME("ch%d",i+1));
  GENLIB_THRU_V(TALU1,2,x);
  GENLIB_COPY_UP_REF(GENLIB_NAME("ch%d",i+1),"trans_0",GENLIB_NAME("ch%d",i+1));
 }

 for(i=0;i<puiss(L);i++)
 {
  GENLIB_COPY_UP_CON_FACE(WEST,"wl",GENLIB_NAME("ram_%d_0",i),GENLIB_NAME("wl%d",i));
  GENLIB_COPY_UP_CON_FACE(WEST,"wlp",GENLIB_NAME("ram_%d_0",i),GENLIB_NAME("wl%d",i));
  GENLIB_COPY_UP_CON_FACE(EAST,"wl",GENLIB_NAME("trans_%d",i),GENLIB_NAME("wl%d",i));
 }
 for(i=0;i<puiss(L);i+=2)
 {
  GENLIB_COPY_UP_CON_FACE(WEST,"vdd",GENLIB_NAME("ram_%d_0",i),GENLIB_NAME("vdd%d",i+10));
  GENLIB_COPY_UP_CON_FACE(EAST,"vdd",GENLIB_NAME("trans_%d",i),GENLIB_NAME("vdd%d",i+10));
 }
  GENLIB_COPY_UP_CON_FACE(WEST,"pcom","prech_0","ckp");
  GENLIB_COPY_UP_CON_FACE(WEST,"vdd","prech_0",GENLIB_NAME("vdd%d",puiss(L)+10));
  GENLIB_COPY_UP_CON_FACE(EAST,"pcom",GENLIB_NAME("prech_%d",puiss(C-1)-1),"ckp");
  GENLIB_COPY_UP_CON_FACE(EAST,"vdd",GENLIB_NAME("prech_%d",puiss(C-1)-1),GENLIB_NAME("vdd%d",puiss(L)+10));
 for(i=0;i<puiss(C-1);i++)
 {
  GENLIB_COPY_UP_CON_FACE(NORTH,"vss",GENLIB_NAME("prech_%d",i),"vss");
  GENLIB_COPY_UP_CON_FACE(NORTH,"vss1",GENLIB_NAME("prech_%d",i),"vss");
  GENLIB_COPY_UP_CON_FACE(NORTH,"vss2",GENLIB_NAME("prech_%d",i),"vss");
  GENLIB_COPY_UP_CON_FACE(NORTH,"vdd",GENLIB_NAME("prech_%d",i),GENLIB_NAME("vdd%d",puiss(L)+10));
 }

 GENLIB_SAVE_PHFIG();
 return(0);
}

decgen(clk)
int clk;
{
 int i,j,k,l,m,num,p,x,y;

 GENLIB_DEF_PHFIG(GENLIB_NAME("predec_%d_%d",L,C));
 
 if(clk==0) GENLIB_PLACE("dtinv3_c","inv",NOSYM,0,0);
 else GENLIB_PLACE("dtinv_c","inv",NOSYM,0,0);
 GENLIB_PLACE_TOP("dtcmp_c","cprech",NOSYM);
 GENLIB_PLACE_TOP("dtcmw_c","write",SYM_Y);
 GENLIB_PLACE_TOP("dtcms_c","csel",NOSYM);
 switch(C)
 {
  case 1:{
          if(un==1) Y = 277;
          else Y = 335;
          GENLIB_PLACE("dtpdc0_c","pdec",NOSYM,0,Y);
          break;
         }
  default:{
           Y = 0;
           GENLIB_PLACE_TOP(GENLIB_NAME("dtpdc%d_c",(C-1)),"pdec",NOSYM);
           break;
          }
 }
 GENLIB_PLACE_TOP("dtpdcl_c","pdecl",SYM_X);
 for(i=0; i<= (L-3);i++)
  GENLIB_PLACE_TOP(GENLIB_NAME("dtbadr%d_c",i), GENLIB_NAME("bufl%d",i), NOSYM);
 if((L==6) && (C==1))
  GENLIB_PLACE_TOP("dtext6_c","ext",NOSYM);
 else
  GENLIB_PLACE_TOP(GENLIB_NAME("dtext%d_c",(L-3)),"ext",NOSYM);


 if(C==1) Y += 293;
 else Y += 426;
/*
 switch(C)
 {
  case 1:{ Y = 618;
           break;
         }
  default:{ Y = 426;
            break;
          }
 }
*/

k=0;
switch(C)
{
 case 4:{
         for(i=0; i<2; i++)
         {
          GENLIB_PLACE("dtbmxl2_c", GENLIB_NAME("mlbuf_%d",i), NOSYM, 0,k+Y);
          GENLIB_PLACE_RIGHT("dtbmxr3_c", GENLIB_NAME("mrbuf_%d", i), SYM_X);
          k+=32;
         }
         for(i=2; i<4; i++)
         {
          GENLIB_PLACE("dtbmxl2y_c", GENLIB_NAME("mlbuf_%d",5-i), SYM_Y, 0,k+Y);
          GENLIB_PLACE_RIGHT("dtbmxr3y_c", GENLIB_NAME("mrbuf_%d",5-i), SYMXY);
          k+=32;
         }
         break;
        }
 case 3:{
         GENLIB_PLACE("dtbmxl2_c", "mlbuf_0", NOSYM, 0,Y);
         GENLIB_PLACE_RIGHT("dtbmxr2_c", "mrbuf_0", SYM_X);
         GENLIB_PLACE("dtbmxe2_c","mbuf_0", NOSYM, 0,Y+32);
         GENLIB_PLACE("dtbmxl2y_c", "mlbuf_1", SYM_Y, 0,Y+93);
         GENLIB_PLACE_RIGHT("dtbmxr2y_c", "mrbuf_1", SYMXY);
        break;
        }
 case 2:{
         GENLIB_PLACE("dtbmxl1_c", "mlbuf_0", NOSYM, 0,Y);
         GENLIB_PLACE_RIGHT("dtbmxr1_c", "mrbuf_0", SYM_X);
         GENLIB_PLACE("dtbmxe1_c","mbuf_0", NOSYM, 0,Y+32);
        break;
        }
 case 1:{
         GENLIB_PLACE("dtbmxl0_c", "mlbuf_0", NOSYM, 0,Y);
         GENLIB_PLACE_RIGHT("dtbmxr0_c", "mrbuf_0", SYM_X);
         GENLIB_PLACE("dtbmxe0_c","mbuf_0", NOSYM, 0,Y+31);
        break;
        }
 default: break;
}

 Y += 125;
 if(C==1) Y -= 4;
 GENLIB_PLACE("dtali2_c","ali",NOSYM,0,Y);

 GENLIB_DEF_AB(0,0,0,0);

 switch(C)
 {
 	case 4: {
		  for(i=0;i<4;i++)
		  {
  		   GENLIB_PLACE_VIA_REF(GENLIB_NAME("mrbuf_%d",i),GENLIB_NAME("v%d",i),CONT_VIA);
		   if(i>1){
 		           GENLIB_WIRE1(ALU1,1,GENLIB_NAME("mrbuf_%d",i),GENLIB_NAME("v%d",i),0,GENLIB_NAME("mrbuf_%d",i),"v1",0);
                          }
		  }
		  for(j=5;j<(L-1);j++)
		  {
		   for(i=0;i<4;i++)
                   {
 		    GENLIB_WIRE1(ALU2,2,GENLIB_NAME("mlbuf_%d",i),GENLIB_NAME("l%dd",j),0,GENLIB_NAME("mlbuf_%d",i),GENLIB_NAME("l%du",j),0);
 		    GENLIB_WIRE1(ALU2,2,GENLIB_NAME("mlbuf_%d",i),GENLIB_NAME("ln%dd",j),0,GENLIB_NAME("mlbuf_%d",i),GENLIB_NAME("ln%du",j),0);
		   }
		  }
                  break;
		}
 	case 3: {
		  for(i=0;i<2;i++)
  		   GENLIB_PLACE_VIA_REF(GENLIB_NAME("mrbuf_%d",i),GENLIB_NAME("v%d",i),CONT_VIA);
		  for(j=5;j<(L-1);j++)
		  {
		   for(i=0;i<2;i++)
                   {
 		    GENLIB_WIRE1(ALU2,2,GENLIB_NAME("mlbuf_%d",i),GENLIB_NAME("l%dd",j),0,GENLIB_NAME("mlbuf_%d",i),GENLIB_NAME("l%du",j),0);
 		    GENLIB_WIRE1(ALU2,2,GENLIB_NAME("mlbuf_%d",i),GENLIB_NAME("ln%dd",j),0,GENLIB_NAME("mlbuf_%d",i),GENLIB_NAME("ln%du",j),0);
		   }
 		    GENLIB_WIRE1(ALU2,2,"mbuf_0",GENLIB_NAME("l%dd",j),0,"mbuf_0",GENLIB_NAME("l%du",j),0);
 		    GENLIB_WIRE1(ALU2,2,"mbuf_0",GENLIB_NAME("ln%dd",j),0,"mbuf_0",GENLIB_NAME("ln%du",j),0);
                  }
                  break;
		}
	case 2:
 	case 1: {
		   for(j=5;j<(L-1);j++)
                   {
 		    GENLIB_WIRE1(ALU2,2,"mlbuf_0",GENLIB_NAME("l%dd",j),0,"mlbuf_0",GENLIB_NAME("l%du",j),0);
 		    GENLIB_WIRE1(ALU2,2,"mlbuf_0",GENLIB_NAME("ln%dd",j),0,"mlbuf_0",GENLIB_NAME("ln%du",j),0);
 		    GENLIB_WIRE1(ALU2,2,"mbuf_0",GENLIB_NAME("l%dd",j),0,"mbuf_0",GENLIB_NAME("l%du",j),0);
 		    GENLIB_WIRE1(ALU2,2,"mbuf_0",GENLIB_NAME("ln%dd",j),0,"mbuf_0",GENLIB_NAME("ln%du",j),0);
		   }
 		    GENLIB_WIRE1(ALU2,50,"csel","vdd",1,"pdec","vdd",0);
 		    GENLIB_WIRE1(ALU2,50,"csel","vdd2",1,"pdec","vdd2",0);
 		    GENLIB_WIRE1(ALU2,50,"csel","vss",1,"pdec","vss",0);
 		    GENLIB_WIRE1(ALU2,50,"csel","vss2",1,"pdec","vss2",0);
 		    GENLIB_WIRE1(ALU2,2,"csel","a0",1,"pdec","a0",0);
 		    GENLIB_WIRE1(ALU2,2,"csel","a1",1,"pdec","a1",0);
 		    GENLIB_WIRE1(ALU2,2,"csel","a2",1,"pdec","a2",0);
 		    GENLIB_WIRE1(ALU2,2,"csel","a3",1,"pdec","a3",0);
                    for(k=0;k<L-6;k++)
                    {
 		     GENLIB_WIRE1(ALU2,2,"csel",GENLIB_NAME("l%du",k+5),0,"pdec",GENLIB_NAME("l%dd",k+5),0);
                    }
 		    GENLIB_WIRE1(ALU2,2,"csel","c0",1,"pdec","c0",0);
 		    GENLIB_WIRE1(ALU2,2,"csel","c1",1,"pdec","c1",0);
 		    GENLIB_WIRE1(ALU2,2,"csel","nck",1,"pdec","nck",0);
 		    GENLIB_WIRE1(ALU2,2,"csel","ck",1,"pdec","ck",0);
 		    GENLIB_WIRE1(ALU2,2,"pdec","in0",0,"csel","l0u",0);
                  break;
		}
	default: break;
 }

 for(j=5;j<(L-1);j++)
 {
  for(i=0;i<(j-1);i++)
  {
   GENLIB_WIRE1(ALU2,2,GENLIB_NAME("bufl%d",i),GENLIB_NAME("l%dd",j),0,GENLIB_NAME("bufl%d",i),GENLIB_NAME("l%du",j),0);
  }
 }

 for(i=5;i<(L-1);i++)
 {
  GENLIB_WIRE1(ALU2,2,"inv",GENLIB_NAME("l%dd",i),0,"inv",GENLIB_NAME("l%du",i),0);
  GENLIB_WIRE1(ALU2,2,"csel",GENLIB_NAME("l%dd",i),0,"csel",GENLIB_NAME("l%du",i),0);
  GENLIB_WIRE1(ALU2,2,"write",GENLIB_NAME("l%dd",i),0,"write",GENLIB_NAME("l%du",i),0);
  GENLIB_WIRE1(ALU2,2,"cprech",GENLIB_NAME("l%dd",i),0,"cprech",GENLIB_NAME("l%du",i),0);
  GENLIB_WIRE1(ALU2,2,"pdec",GENLIB_NAME("l%dd",i),0,"pdec",GENLIB_NAME("l%du",i),0);
  GENLIB_WIRE1(ALU2,2,"pdecl",GENLIB_NAME("l%dd",i),0,"pdecl",GENLIB_NAME("l%du",i),0);
  GENLIB_WIRE1(ALU2,2,"ali",GENLIB_NAME("l%dd",i),0,"ali",GENLIB_NAME("l%dw",i),0);
  GENLIB_WIRE1(ALU2,2,"ali",GENLIB_NAME("l%dw",i),0,"ali",GENLIB_NAME("l%de",i),0);
  GENLIB_WIRE1(ALU2,2,"ali",GENLIB_NAME("l%de",i),0,"ali",GENLIB_NAME("l%du",i),0);
  GENLIB_WIRE1(ALU2,2,"ali",GENLIB_NAME("ln%dd",i),0,"ali",GENLIB_NAME("ln%dw",i),0);
  GENLIB_WIRE1(ALU2,2,"ali",GENLIB_NAME("ln%dw",i),0,"ali",GENLIB_NAME("ln%de",i),0);
  GENLIB_WIRE1(ALU2,2,"ali",GENLIB_NAME("ln%de",i),0,"ali",GENLIB_NAME("ln%du",i),0);
 }

 switch(C)
 {
  case 4:
  case 3:{
          GENLIB_WIRE1(ALU2,2,"ali","vd",0,"ali","vdu",0);
          GENLIB_WIRE1(ALU2,2,"ali","vd1d",0,"ali","vd1u",0);
          GENLIB_WIRE1(ALU2,2,"ali","vsd",0,"ali","vsw",0);
          GENLIB_WIRE1(ALU2,2,"ali","vsw",0,"ali","vse",0);
          GENLIB_WIRE1(ALU2,2,"ali","vse",0,"ali","vsu",0);
          GENLIB_WIRE1(ALU2,2,"ali","vs2d",0,"ali","vs2u",0);
          for(i=1;i<=4;i++)
          {
           GENLIB_PLACE_VIA_REF("ali",GENLIB_NAME("cv%d",i),CONT_VIA);
           GENLIB_PLACE_VIA_REF("ali",GENLIB_NAME("cv%d",i+10),CONT_VIA);
           GENLIB_PLACE_VIA_REF("ali",GENLIB_NAME("cv%d",i+20),CONT_VIA);
           GENLIB_PLACE_VIA_REF("ali",GENLIB_NAME("cv%d",i+30),CONT_VIA);
          }
          break;
         }
  default:break;
 }
          
 for(i=0;i<C;i++)
 {
  GENLIB_WIRE1(ALU2,2,"inv",GENLIB_NAME("l%dd",i),0,"csel",GENLIB_NAME("l%du",i),0);
 }
 for(i=0;i<(C*2);i++)
 {
  GENLIB_WIRE1(ALU2,2,"pdecl",GENLIB_NAME("mm%d",i),0,"ext",GENLIB_NAME("mm%d",i),0);
 }
 switch(C)
 {
  case 4:
  case 3:{
          for(i=0;i<2;i++)
          {
           x = GENLIB_GET_REF_X("inv",GENLIB_NAME("l%d",i));
           GENLIB_PHCON(ALU2,2,GENLIB_NAME("adr[%d]",i+1),SOUTH,x,0);
          }
          for(i=0;i<C-2;i++)
          {
           x = GENLIB_GET_REF_X("inv",GENLIB_NAME("l%d",i+2));
           GENLIB_PHCON(ALU2,2,GENLIB_NAME("adr[%d]",i*3),SOUTH,x,0);
          }
          break;
         }
  case 2:
  case 1:{
          for(i=0;i<C;i++)
          {
           x = GENLIB_GET_REF_X("inv",GENLIB_NAME("l%d",i));
           GENLIB_PHCON(ALU2,2,GENLIB_NAME("adr[%d]",i),SOUTH,x,0);
          }
          break;
         }
  default: break;
 }

  x = GENLIB_GET_REF_X("inv","cp0");
  GENLIB_PHCON(ALU2,2,GENLIB_NAME("adr[%d]",C),SOUTH,x,0);
  x = GENLIB_GET_REF_X("inv","cp1");
  GENLIB_PHCON(ALU2,2,GENLIB_NAME("adr[%d]",C+1),SOUTH,x,0);
 j= C+2;
 switch(L)
 {
  case 8:{
          x = GENLIB_GET_REF_X("inv","l6");
          GENLIB_PHCON(ALU2,2,GENLIB_NAME("adr[%d]",j),SOUTH,x,0);
          x = GENLIB_GET_REF_X("inv","l5");
          GENLIB_PHCON(ALU2,2,GENLIB_NAME("adr[%d]",j+1),SOUTH,x,0);
          j+=2;
          break;
         }
  case 7:{
          x = GENLIB_GET_REF_X("inv","l5");
          GENLIB_PHCON(ALU2,2,GENLIB_NAME("adr[%d]",j),SOUTH,x,0);
          j++;
          break;
         }
  default:break;
 }
 for(i=0;i<4;i++)
 {
  x = GENLIB_GET_REF_X("inv",GENLIB_NAME("l%d",10+i));
  GENLIB_PHCON(ALU2,2,GENLIB_NAME("adr[%d]",i+j),SOUTH,x,0);
 }

 GENLIB_COPY_UP_CON(0,"vdd","inv","vdd");
 GENLIB_COPY_UP_CON(0,"vdd2","inv","vdd");
 GENLIB_COPY_UP_CON(0,"vss","inv","vss");
 GENLIB_COPY_UP_CON(0,"vss2","inv","vss");
 GENLIB_COPY_UP_CON(0,"write","inv","write");
 GENLIB_COPY_UP_CON(0,"ck","inv","ck");
 GENLIB_COPY_UP_CON(0,"en","inv","en");
 GENLIB_COPY_UP_CON(0,"cpr","cprech","cpr");
 GENLIB_COPY_UP_CON(0,"cpl","cprech","cpl");
 GENLIB_COPY_UP_CON(0,"cwr","write","cwr");
 GENLIB_COPY_UP_CON(0,"cwl","write","cwl");
 GENLIB_COPY_UP_CON(0,"csr","csel","csr");
 GENLIB_COPY_UP_CON(0,"csl","csel","csl");

 switch(C)
 {
  case 4:
  case 3:{
          for(i=0;i<2;i++)
          {
           for(j=0;j<C-2;j++)
           {
            for(k=0;k<4;k++)
            {
             GENLIB_COPY_UP_CON_FACE(WEST,GENLIB_NAME("s%d",k),GENLIB_NAME("mlbuf_%d",i*(C-2)+j),GENLIB_NAME("sel_%d",j*8+k*2+1-i));
             GENLIB_COPY_UP_CON_FACE(EAST,GENLIB_NAME("s%d",k),GENLIB_NAME("mrbuf_%d",i*(C-2)+j),GENLIB_NAME("sel_%d",j*8+k*2+1-i));
            } 
           }
          }
          break;
         }
  case 2:{
          GENLIB_COPY_UP_CON_FACE(WEST,"s0","mlbuf_0","sel_0");
          GENLIB_COPY_UP_CON_FACE(EAST,"s0","mrbuf_0","sel_0");
          GENLIB_COPY_UP_CON_FACE(WEST,"s1","mlbuf_0","sel_1");
          GENLIB_COPY_UP_CON_FACE(EAST,"s1","mrbuf_0","sel_1");
          GENLIB_COPY_UP_CON_FACE(WEST,"s2","mlbuf_0","sel_2");
          GENLIB_COPY_UP_CON_FACE(EAST,"s3","mrbuf_0","sel_3");
          GENLIB_COPY_UP_CON_FACE(WEST,"sel0","mbuf_0","sel_3");
          GENLIB_COPY_UP_CON_FACE(EAST,"sel1","mbuf_0","sel_2");
          break;
         }
  case 1:{
          GENLIB_COPY_UP_CON_FACE(WEST,"s0","mlbuf_0","sel_1");
          GENLIB_COPY_UP_CON_FACE(EAST,"s0","mrbuf_0","sel_1");
          GENLIB_COPY_UP_CON_FACE(WEST,"sel0","mbuf_0","sel_0");
          GENLIB_COPY_UP_CON_FACE(EAST,"sel1","mbuf_0","sel_0");
          break;
         }
   default: break;
 }
 for(i=0;i<4;i++)
 {
  GENLIB_COPY_UP_CON_FACE(NORTH,GENLIB_NAME("ba%d",i),"ali",GENLIB_NAME("ba_%d",i));
  GENLIB_COPY_UP_CON_FACE(NORTH,GENLIB_NAME("bna%d",i),"ali",GENLIB_NAME("bna_%d",i));
  GENLIB_COPY_UP_CON_FACE(NORTH,GENLIB_NAME("cp%d",i),"ali",GENLIB_NAME("cp%d",i));
 }
 GENLIB_COPY_UP_CON_FACE(NORTH,"nck","ali","nck");
 GENLIB_COPY_UP_CON_FACE(NORTH,"ck_en","ali","ck_en");
 GENLIB_COPY_UP_CON_FACE(EAST,"vdd","ali","vdd");
 GENLIB_COPY_UP_CON_FACE(WEST,"vdd","ali","vdd");
 GENLIB_COPY_UP_CON_FACE(EAST,"vss","ali","vss");
 GENLIB_COPY_UP_CON_FACE(WEST,"vss","ali","vss");
 GENLIB_COPY_UP_CON_FACE(NORTH,"vdd","ali","vdd");
 GENLIB_COPY_UP_CON_FACE(NORTH,"vss","ali","vss");

 for(i=4;i<L-2;i++)
 {
  x = GENLIB_GET_REF_X("ali",GENLIB_NAME("l%du",i+1));
  y = GENLIB_GET_REF_Y("ali",GENLIB_NAME("l%du",i+1));
  GENLIB_PHCON(ALU2,2,GENLIB_NAME("ba_%d",i),NORTH,x,y);
  x = GENLIB_GET_REF_X("ali",GENLIB_NAME("ln%du",i+1));
  y = GENLIB_GET_REF_Y("ali",GENLIB_NAME("ln%du",i+1));
  GENLIB_PHCON(ALU2,2,GENLIB_NAME("bna_%d",i),NORTH,x,y);
 }

/*
 FLATTEN_PHFIG("inv",YES);
 FLATTEN_PHFIG("csel",YES);
 FLATTEN_PHFIG("write",YES);
 FLATTEN_PHFIG("cprech",YES);
 FLATTEN_PHFIG("pdec",YES);
 FLATTEN_PHFIG("pdecl",YES);
 for(i=0;i<(L-2);i++)
 {
  FLATTEN_PHFIG(GENLIB_NAME("bufl%d",i),YES);
 }
 FLATTEN_PHFIG("ext",YES);

 switch(C)
 {
    case 4:{
            for(i=0;i<4;i++)
            {
             FLATTEN_PHFIG(GENLIB_NAME("mlbuf_%d",i),YES);
             FLATTEN_PHFIG(GENLIB_NAME("mrbuf_%d",i),YES);
            }
            break;
           } 
    case 3:{
            for(i=0;i<2;i++)
            {
             FLATTEN_PHFIG(GENLIB_NAME("mlbuf_%d",i),YES);
             FLATTEN_PHFIG(GENLIB_NAME("mrbuf_%d",i),YES);
            }
            FLATTEN_PHFIG("mbuf_0",YES);
            break;
           } 
    case 2:
    case 1:{
            FLATTEN_PHFIG("mlbuf_0",YES);
            FLATTEN_PHFIG("mrbuf_0",YES);
            FLATTEN_PHFIG("mbuf_0",YES);
            break;
           } 
    default: break;
 }
 FLATTEN_PHFIG("ali",YES);
*/


 GENLIB_SAVE_PHFIG();

 GENLIB_DEF_PHFIG(GENLIB_NAME("%s_dec",IDENTIF));
 if(C==1) {
           if(un==0){
                     GENLIB_PLACE("dtedg0_c","bord1",NOSYM,0,0);
                     GENLIB_PLACE("dtedg0_c","bord2",SYM_X,408,0);
                    }
           else {
                 GENLIB_PLACE("dtedg1_c","bord1",NOSYM,0,0);
                 GENLIB_PLACE("dtedg1_c","bord2",SYM_X,408,0);
                }
          }
 else {
       if(un==0){
                 GENLIB_PLACE("dtedg2_c","bord1",NOSYM,0,0);
                }
       else {
             GENLIB_PLACE("dtedg3_c","bord1",NOSYM,0,0);
            }
      
       GENLIB_PLACE_TOP(GENLIB_NAME("dtmxeg%d_c",C),"mxabg",NOSYM);
       if(un==0){
                 GENLIB_PLACE("dtedg2_c","bord2",SYM_X,408,0);
                }
       else {
             GENLIB_PLACE("dtedg3_c","bord2",SYM_X,408,0);
            }
       GENLIB_PLACE_TOP(GENLIB_NAME("dtmxed%d_c",C),"mxabd",SYM_X);
      }
  

 GENLIB_PLACE(GENLIB_NAME("predec_%d_%d",L,C),"prdecod",NOSYM,13,0);

 Y = 670;
 if (C==1) {
            if(un==0) Y += 198;
            else Y += 140;
           }

 j=decod();
 
 GENLIB_PLACE("dtpcg_c", "COMPG", NOSYM,13,Y);

 GENLIB_DEF_AB(0,0,0,0);

 num=(L-2)*10;

 m= puiss(L-2);

 for(i=0;i<m;i++)
 {
  for(j=5;j<(L-1);j++)
  {
   GENLIB_WIRE1(ALU1,1,GENLIB_NAME("adr_%d",i),GENLIB_NAME("l%de",j),0,GENLIB_NAME("adr_%d",i),GENLIB_NAME("l%dw",j),0);
  }
 }
  
 p=0;
 for(i=1;i<m;i=i*2)
 {
  l=0;
  j=0;
  while(j<m)
  {
   for(k=0;k<i;k++)
   {
    if(l==0)GENLIB_PLACE_VIA_REF(GENLIB_NAME("ADR_%d",j),GENLIB_NAME("c%dn",(num+p)),CONT_VIA);
    else GENLIB_PLACE_VIA_REF(GENLIB_NAME("ADR_%d",j),GENLIB_NAME("c%d",(num+p)),CONT_VIA);
    j++;
   }
   if(l==0)l=1;
   else l=0;
  }
  p++;
 }
 for(i=0;i<(L-6);i++)
 {
  GENLIB_WIRE1(ALU2,2,"adr_0",GENLIB_NAME("l%dd",i+5),0,GENLIB_NAME("adr_%d",puiss(L-2)-1),GENLIB_NAME("l%du",i+5),0);
  GENLIB_WIRE1(ALU2,2,"adr_0",GENLIB_NAME("ln%dd",i+5),0,GENLIB_NAME("adr_%d",puiss(L-2)-1),GENLIB_NAME("ln%du",i+5),0);
 }
 GENLIB_COPY_UP_ALL_CON(SOUTH,"prdecod", NO);
 switch(C)
 {
  case 1:{
          for(i=0;i<puiss(C);i++)
          {
           GENLIB_COPY_UP_CON_FACE(WEST,GENLIB_NAME("sel_%d",i),"prdecod",GENLIB_NAME("sel_%d",i));
           GENLIB_COPY_UP_CON_FACE(EAST,GENLIB_NAME("sel_%d",i),"prdecod",GENLIB_NAME("sel_%d",i));
          }
          break;
         }
  default:{
           for(i=0;i<puiss(C);i++)
           {
            GENLIB_COPY_UP_CON_FACE(WEST,GENLIB_NAME("sel%d",i),"mxabg",GENLIB_NAME("sel[%d]",i));
            GENLIB_COPY_UP_CON_FACE(EAST,GENLIB_NAME("sel%d",i),"mxabd",GENLIB_NAME("sel[%d]",i));
           }
           break;
          }
 }

 switch(C)
 {
  case 1:{
          if(un==0){
                    j= 5;
                    k= 4;
                   }
          else{
               j= 4;
               k= 5;
              }
          break;
         }
  case 2:
  case 3:
  case 4:{
          j= 3;
          k= 2;
          break;
         }
  default: break;
 }
 GENLIB_COPY_UP_CON_FACE(WEST,"vdd","prdecod","vdd");
 GENLIB_COPY_UP_CON_FACE(EAST,"vdd","prdecod","vdd");
 GENLIB_COPY_UP_CON_FACE(WEST,"vss","prdecod","vss");
 GENLIB_COPY_UP_CON_FACE(EAST,"vss","prdecod","vss");
 
 GENLIB_COPY_UP_CON_FACE(WEST,"cw","bord1","cwl");
 GENLIB_COPY_UP_CON_FACE(WEST,"cp","bord1","cpl");
 GENLIB_COPY_UP_CON_FACE(WEST,"cs","bord1","csl");
 GENLIB_COPY_UP_CON_FACE(EAST,"cw","bord2","cwr");
 GENLIB_COPY_UP_CON_FACE(EAST,"cp","bord2","cpr");
 GENLIB_COPY_UP_CON_FACE(EAST,"cs","bord2","csr");

 for(i=1;i<=j;i++)
 {
  GENLIB_COPY_UP_CON_FACE(WEST,GENLIB_NAME("vdd%d",i),"bord1","vdd");
  GENLIB_COPY_UP_CON_FACE(EAST,GENLIB_NAME("vdd%d",i),"bord2","vdd");
 }

 for(i=1;i<=k;i++)
 {
  GENLIB_COPY_UP_CON_FACE(WEST,GENLIB_NAME("vss%d",i),"bord1","vss");
  GENLIB_COPY_UP_CON_FACE(EAST,GENLIB_NAME("vss%d",i),"bord2","vss");
 }

 for(i=0;i<puiss(L-2);i++)
 {
  for(j=0;j<4;j++)
  {
   for(k=0;k<2;k++)
   {
    GENLIB_COPY_UP_CON(k,GENLIB_NAME("wld[%d]",j),GENLIB_NAME("decd_%d",i),GENLIB_NAME("wld[%d]",j+i*4));
    GENLIB_COPY_UP_CON(k,GENLIB_NAME("wlg[%d]",j),GENLIB_NAME("decg_%d",i),GENLIB_NAME("wlg[%d]",j+i*4));
   }
  }
  GENLIB_COPY_UP_CON_FACE(WEST,"vdd",GENLIB_NAME("decg_%d",i),"vdd");
  GENLIB_COPY_UP_CON_FACE(EAST,"vdd",GENLIB_NAME("decd_%d",i),"vdd");
 }
 GENLIB_COPY_UP_CON(0,"ckp","compg","ckp");
 GENLIB_COPY_UP_CON(0,"ckp2","compg","ckp2");
 GENLIB_COPY_UP_CON_FACE(NORTH,"vdd1","compg","vdd");
 GENLIB_COPY_UP_CON_FACE(WEST,"vdd1","compg","vdd");
 GENLIB_COPY_UP_CON_FACE(NORTH,"vdd2","compg","vdd");
 GENLIB_COPY_UP_CON_FACE(EAST,"vdd2","compg","vdd");
 GENLIB_COPY_UP_CON_FACE(NORTH,"vdd3","compg","vdd");
 GENLIB_COPY_UP_CON_FACE(NORTH,"vss1","compg","vss");
 GENLIB_COPY_UP_CON_FACE(NORTH,"vss2","compg","vss");
	
 GENLIB_SAVE_PHFIG();

 return(0);
}

copcon()
{
 int i,j,k;
 long x;

 for(i=0;i<2;i++)
 {
  for(j=0;j<bpm2;j++)
  {
   if(un==1){
             GENLIB_COPY_UP_CON(0,"inn",GENLIB_NAME("rbit_%d_%d",j,i),GENLIB_NAME("din[%d]",j+i*bpm2));
            }
   GENLIB_COPY_UP_CON(0,"dout",GENLIB_NAME("rbit_%d_%d",j,i),GENLIB_NAME("dout[%d]",j+i*bpm2));
   for(k=0;k<tr;k++)
   {
    x = GENLIB_GET_REF_X(GENLIB_NAME("rbit_%d_%d",j,i),GENLIB_NAME("ch%d",k+1));
    GENLIB_THRU_V(TALU1,2,x);
    GENLIB_COPY_UP_REF(GENLIB_NAME("ch%d",k+1),GENLIB_NAME("rbit_%d_%d",j,i),GENLIB_NAME("ch%d",k+1));
   }
   for(k=0;k<puiss(C-1);k++)
   {
    GENLIB_COPY_UP_CON_FACE(NORTH,GENLIB_NAME("vdd%d",puiss(L)+10),GENLIB_NAME("rbit_%d_%d",j,i),"vdd");
   }
   GENLIB_COPY_UP_CON_FACE(NORTH,"vss",GENLIB_NAME("rbit_%d_%d",j,i),"vss");
  }
 }
 GENLIB_COPY_UP_ALL_CON(SOUTH,"decod", NO);
 GENLIB_COPY_UP_ALL_CON(NORTH,"decod", NO);

 GENLIB_COPY_UP_CON_FACE(WEST,"vdd","rbit_0_0","vdd");
 GENLIB_COPY_UP_CON_FACE(WEST,"vss","rbit_0_0","vss");
 GENLIB_COPY_UP_CON_FACE(EAST,"vdd",GENLIB_NAME("rbit_%d_1",bpm2-1),"vdd");
 GENLIB_COPY_UP_CON_FACE(EAST,"vss",GENLIB_NAME("rbit_%d_1",bpm2-1),"vss");
 switch(C)
 {
  case 1:{
          if(un==0){
                    j= 5;
                    k= 5;
                   }
          else{
               j= 4;
               k= 5;
              }
          break;
         }
  case 2:
  case 3:
  case 4:{
          j= 3;
          k= 2;
          break;
         }
  default: break;
 }
 for(i=1;i<=j;i++)
 {
  GENLIB_COPY_UP_CON_FACE(WEST,GENLIB_NAME("vdd%d",i),"rbit_0_0","vdd");
  GENLIB_COPY_UP_CON_FACE(EAST,GENLIB_NAME("vdd%d",i),GENLIB_NAME("rbit_%d_1",bpm2-1),"vdd");
 }
 for(i=1;i<=k;i++)
 {
  GENLIB_COPY_UP_CON_FACE(WEST,GENLIB_NAME("vss%d",i),"rbit_0_0","vss");
  GENLIB_COPY_UP_CON_FACE(EAST,GENLIB_NAME("vss%d",i),GENLIB_NAME("rbit_%d_1",bpm2-1),"vss");
 }

 for(i=10;i<puiss(L)+10;i+=2)
 {
  GENLIB_COPY_UP_CON_FACE(WEST,GENLIB_NAME("vdd%d",i),"rbit_0_0","vdd");
  GENLIB_COPY_UP_CON_FACE(EAST,GENLIB_NAME("vdd%d",i),GENLIB_NAME("rbit_%d_1",bpm2-1),"vdd");
 }

}

outline()
{
 GENLIB_OUTLINE();
}

rage_icon(name)
char *name;
{
 long x,y,a,b;
 int i,j;

 ADDICONGATE(name, 50, 35, 50, 30, 50, 25);

 ADDICONCON(GENLIB_NAME("adr[%d:0]",L+C -1), 25, 80, SAX_NORTH, IN);
 ADDICONCON("ck", 40, 80, SAX_NORTH, IN);
 ADDICONCON("en", 60, 80, SAX_NORTH, IN);
 ADDICONCON("write", 75, 80, SAX_NORTH, IN);
 if(un==1)
 {
 ADDICONCON(GENLIB_NAME("din[%d:0]",bpm -1), 100, 40, SAX_EAST, IN);
 ADDICONCON(GENLIB_NAME("dout[%d:0]",bpm -1), 0, 40, SAX_WEST, OUT);
 }
 else ADDICONCON(GENLIB_NAME("dout[%d:0]",bpm -1), 0, 40, SAX_WEST, INOUT);

 ADDICONCON("vdd", 30, 0, SAX_SOUTH, IN);
 ADDICONCON("vss", 70, 0, SAX_SOUTH, IN);
 x = 37;
 y = 40;
     for(i=1;i<6;i++)
     {
      a=x;
      b=y+i*2-1;
      for(j=1;j<5;j++)
      {
        ADDICONLINE(a,b,a+2,b);
        a+=2;
        ADDICONLINE(a,b,a+1,b-1);
        ADDICONLINE(a,b,a+1,b+1);
        a+=1;
        b-=1;
        ADDICONLINE(a,b,a+2,b);
        a+=2;
        ADDICONLINE(a,b+2,a+1,b+1);
        ADDICONLINE(a,b,a+1,b+1);
        a+=1;
        b+=1;
      }
      ADDICONLINE(a,b,a+2,b);
     }
      a=x+2;
      b=y+9;
      for(j=1;j<5;j++)
      {
        ADDICONLINE(a,b,a+1,b+1);
        a+=1;
        b+=1;
        ADDICONLINE(a,b,a+2,b);
        a+=2;
        ADDICONLINE(a,b,a+1,b-1);
        a+=3;
        b-=1;
      }
        
        ADDICONLINE(30, 0, 30, 20);
        ADDICONLINE(70, 0, 70, 20);
        ADDICONLINE(0, 40, 20, 40);
        ADDICONLINE(25, 60, 25, 80);
        ADDICONLINE(40, 60, 40, 80);
        ADDICONLINE(60, 60, 60, 80);
        ADDICONLINE(75, 60, 75, 80);
 if(un==1) ADDICONLINE(80,40,100,40);
        ADDICONCOMP(COMP_ISLINE, 20, 20);
        ADDICONCOMP(COMP_ISLINE, 80 , 20);
        ADDICONCOMP(COMP_ISLINE, 80 , 60);
        ADDICONCOMP(COMP_ISLINE, 20, 60);
        ADDICONSHAPE();
 SAVEICON();
 
}

vhdl(name,clk)
char *name;
int clk;
{
 int i;
 
 i = decvb(L,C,clk,bpm2,name);
 i = gener(L,C,un,bpm2,name);
 i = gvst2(L,C,bpm2,un,name);
}

int decvb(l,c,edge,n,xname)
int l,c,edge,n;
char *xname;
{
 FILE *fich;
 int i,j,k;
 char name[100];

 if(*xname != '\0')
  sprintf(name,"%s_dec.vbe\0",xname);
 else
   sprintf(name,"mem_%d_%d_%d_dec.vbe\0",n*2,l,c);
 
 fich = fopen(name, "w");
 if(*xname != '\0')
  sprintf(name,"%s_dec\0",xname);
 else
   sprintf(name,"mem_%d_%d_%d_dec\0",n*2,l,c);
 fprintf(fich,"ENTITY  %s IS\n",name);

 fprintf(fich,"PORT (\n"); 
 fprintf(fich,"   adr	:	IN BIT_VECTOR(%d DOWNTO 0);\n",l+c-1);
 fprintf(fich,"   wld	:	OUT BIT_VECTOR(%d DOWNTO 0);\n",puiss(l)-1);
 fprintf(fich,"   wlg	:	OUT BIT_VECTOR(%d DOWNTO 0);\n",puiss(l)-1);
 fprintf(fich,"   sel	:   	OUT BIT_VECTOR(%d DOWNTO 0);\n",puiss(c)-1);
 fprintf(fich,"   write :	IN BIT ;\n");
 fprintf(fich,"   cpl	:	OUT BIT ;\n");
 fprintf(fich,"   cpr	:	OUT BIT ;\n");
 fprintf(fich,"   cwl	:	OUT BIT ;\n");
 fprintf(fich,"   cwr	:	OUT BIT ;\n");
 fprintf(fich,"   csl	:	OUT BIT ;\n");
 fprintf(fich,"   csr	:	OUT BIT ;\n");
 fprintf(fich,"   ckp	:	OUT BIT ;\n");
 fprintf(fich,"   ckp2	:	OUT BIT ;\n");
 fprintf(fich,"   ck	:   	IN BIT ;\n");
 fprintf(fich,"   en	:   	IN BIT ;\n");
 fprintf(fich,"   vdd	:   	IN BIT ;\n");
 fprintf(fich,"   vss	:   	IN BIT) ;\n");
 fprintf(fich,"END %s ;\n",name);
 fprintf(fich,"\n\n\n"); 
 fprintf(fich,"ARCHITECTURE decarch OF %s IS \n",name);
 for(i=0;i<l-3;i++)
 {
  fprintf(fich," signal wl%d : BIT_VECTOR(%d DOWNTO 0);\n",i,puiss(4+i)-1);
 }
 for(i=0;i<c;i++)
 {
  fprintf(fich," signal sl%d : BIT_VECTOR(%d DOWNTO 0);\n",i,puiss(i+1)-1);
 }
/*
  fprintf(fich," signal vck : BIT_VECTOR(%d DOWNTO 0);\n",puiss(l)-1);
*/

 fprintf(fich,"\n\n\n");
 fprintf(fich,"begin\n");
 fprintf(fich,"--  word-line calculations --\n\n\n");

 fprintf(fich,"  with adr(%d DOWNTO %d) select\n",c+3,c);
 fprintf(fich,"  wl0 <= B\"0000000000000001\" when B\"0000\",\n");
 for(i=1;i<16;i++)
 {
  fprintf(fich,"         B\"");
  for(j=0;j<15-i;j++)
  {
   fprintf(fich,"0");
  }
   fprintf(fich,"1");
  for(j=16-i;j<16;j++)
  {
   fprintf(fich,"0");
  }
  fprintf(fich,"\" when B\"");
  j=i;
  for(k=3;k>=0;k--)
  {
   if(j>=puiss(k)) {
                    fprintf(fich,"1");
                    j = j - puiss(k);
                   }
   else fprintf(fich,"0");
  }
  if(i==15) fprintf(fich,"\";\n");
  else fprintf(fich,"\" ,\n");
 }
 fprintf(fich,"\n\n\n");

 for(i=4;i<l;i++)
 {
  fprintf(fich,"  with adr(%d) select\n",c+i);
  fprintf(fich,"  wl%d <= wl%d(%d DOWNTO 0) & X\"",i-3,i-4,puiss(i)-1);
  for(j=0;j<puiss(i-2);j++)
  {
   fprintf(fich,"0");
  }
  fprintf(fich,"\" when '1',\n");
  fprintf(fich,"         X\"");
  for(j=0;j<puiss(i-2);j++)
  {
   fprintf(fich,"0");
  }
  fprintf(fich,"\" & wl%d(%d DOWNTO 0) when '0';\n",i-4,puiss(i)-1);
  fprintf(fich,"\n");
 } 
 fprintf(fich,"\n");
/*
 fprintf(fich,"  with ck select\n");
 fprintf(fich,"  vck <= X\"");
 for(j=0;j<puiss(l-2);j++)
 {
  fprintf(fich,"0");
 }
 fprintf(fich,"\" when '1',\n");
 fprintf(fich,"         X\"");
 for(j=0;j<puiss(l-2);j++)
 {
  fprintf(fich,"f");
 }
 fprintf(fich,"\" when '0';\n");
*/
 fprintf(fich,"\n");

 fprintf(fich,"\n");
 fprintf(fich,"  wld <= wl%d; \n",l-4);
 fprintf(fich,"  wlg <= wl%d; \n",l-4);
 fprintf(fich,"\n\n\n");
 fprintf(fich,"--  sel-lines calculation --\n\n\n");

 fprintf(fich,"  with adr(0) select\n");
 fprintf(fich,"  sl0 <= B\"01\" when '0',\n");
 fprintf(fich,"         B\"10\" when '1';\n");
 fprintf(fich,"\n");

 for(i=1;i<c;i++)
 {
  fprintf(fich,"  with adr(%d) select\n",i);
  fprintf(fich,"  sl%d <= sl%d(%d DOWNTO 0) & B\"",i,i-1,puiss(i)-1);
  for(j=0;j<puiss(i);j++)
  {
   fprintf(fich,"0");
  }
  fprintf(fich,"\" when '1',\n");
  fprintf(fich,"         B\"");
  for(j=0;j<puiss(i);j++)
  {
   fprintf(fich,"0");
  }
  fprintf(fich,"\" & sl%d(%d DOWNTO 0) when '0';\n",i-1,puiss(i)-1);
  fprintf(fich,"\n");
 } 

 fprintf(fich,"   sel <= sl%d;\n\n",c-1);

 if(edge==0)
 {
  fprintf(fich,"   cpl  <= not(ck and en) ;\n");
  fprintf(fich,"   cpr  <= not(ck and en) ;\n");
  fprintf(fich,"   cwl <= (ck and en) and write ;\n");
  fprintf(fich,"   cwr <= (ck and en) and write ;\n");
  fprintf(fich,"   csl  <= (ck and en) and not(write) ;\n");
  fprintf(fich,"   csr  <= (ck and en) and not(write) ;\n");
  fprintf(fich,"   ckp  <= not(ck and en) ;\n");
  fprintf(fich,"   ckp2 <= not(ck and en) ;\n\n\n");
 }
 else
 {
  fprintf(fich,"   cpl  <= not(not(ck) and en) ;\n");
  fprintf(fich,"   cpr  <= not(not(ck) and en) ;\n");
  fprintf(fich,"   cwl <= (not(ck) and en) and write ;\n");
  fprintf(fich,"   cwr <= (not(ck) and en) and write ;\n");
  fprintf(fich,"   csl  <= (not(ck) and en) and not(write) ;\n");
  fprintf(fich,"   csr  <= (not(ck) and en) and not(write) ;\n");
  fprintf(fich,"   ckp  <= not(not(ck) and en) ;\n");
  fprintf(fich,"   ckp2 <= not(not(ck) and en) ;\n\n\n");
 }

 fprintf(fich," END decarch ;\n");
 fclose(fich);
}

char valeur(i)
int i;
{
 switch(i)
 {
  case 1:{ return('1'); break;}
  case 2:{ return('2'); break;}
  case 3:{ return('3'); break;}
  case 4:{ return('4'); break;}
  case 5:{ return('5'); break;}
  case 6:{ return('6'); break;}
  case 7:{ return('7'); break;}
  case 8:{ return('8'); break;}
  case 9:{ return('9'); break;}
  case 0:{ return('0'); break;}
  default: break;
 }
}

int gener(l,c,u,n,xname)
int l,c,u,n;
char *xname;
{
 FILE *fich;
 int i,j,k;
 char name[100];

 if(*xname != '\0')
  sprintf(name,"%s_col.vbe\0",xname);
 else
   sprintf(name,"mem_%d_%d_%d_col.vbe\0",n*2,l,c);

 fich = fopen(name, "w");
 if(*xname != '\0')
  sprintf(name,"%s_col\0",xname);
 else
   sprintf(name,"mem_%d_%d_%d_col\0",n*2,l,c);
 fprintf(fich,"ENTITY %s IS\n",name);

 fprintf(fich,"PORT (\n"); 
 fprintf(fich,"   wl	:	IN BIT_VECTOR(0 TO %d);\n",puiss(l)-1);
 fprintf(fich,"   sel	:   	IN BIT_VECTOR(0 TO %d);\n",puiss(c)-1);
 fprintf(fich,"   read	:   	IN BIT ;\n");
 fprintf(fich,"   write :	IN BIT ;\n");
 fprintf(fich,"   ckp   :	IN BIT ;\n");
 fprintf(fich,"   ckp2  :	IN BIT ;\n");
 if(u==1){
 fprintf(fich,"   ent	:   	IN BIT;\n");
 fprintf(fich,"   sor	:   	OUT BIT;\n");
         }
 else {
 fprintf(fich,"   sor	:   	INOUT MUX_BIT BUS ;\n");
      }
 fprintf(fich,"   vdd	:	IN BIT ;\n");
 fprintf(fich,"   vss	:	IN BIT) ;\n");
 fprintf(fich,"END %s ;\n",name);
 fprintf(fich,"\n\n\n"); 
 fprintf(fich,"ARCHITECTURE rbitarch OF %s IS \n",name);
 for(i=0;i<l;i++)
 {
  fprintf(fich," signal wl%d : BIT_VECTOR(0 TO %d);\n",i,puiss(l-i)-1);
 }
 fprintf(fich," signal wla : BIT_VECTOR(0 TO %d);\n",l-1);
 for(i=0;i<c;i++)
 {
  fprintf(fich," signal sl%d : BIT_VECTOR(0 TO %d);\n",i,puiss(c-i)-1);
 }
 if(c==1) fprintf(fich," signal csa : BIT;\n");
 else fprintf(fich," signal csa : BIT_VECTOR(0 TO %d);\n",c-1);
 for(i=0;i<16;i++)
 {
  fprintf(fich," signal mem%d : REG_VECTOR(0 TO %d) REGISTER ;\n",i,puiss(l+c-4)-1);
 }
 fprintf(fich,"  signal msig0 : BIT_VECTOR(0 TO %d);\n",puiss(l+c-4)-1);
 fprintf(fich,"  signal msig1 : BIT_VECTOR(0 TO %d);\n",puiss(c)-1);
 fprintf(fich,"  signal msig2 : BIT_VECTOR(0 TO %d);\n",puiss(c)-1);
 fprintf(fich,"  signal msig3 : BIT_VECTOR(0 TO %d);\n",puiss(l+c-4)-1);
 fprintf(fich,"  signal msig4 : BIT_VECTOR(0 TO 15);\n");
 if(u==0){
          fprintf(fich,"  signal kar   : BIT; \n");
         }

 fprintf(fich,"begin\n");
 fprintf(fich,"--  Recoding --\n\n\n");

 fprintf(fich,"  wl0 <= wl ;\n");
 for(i=0;i<l;i++)
 {
  fprintf(fich,"  with wl%d(0 TO %d) select\n",i,puiss(l-1-i)-1);
  fprintf(fich,"  wla(%d) <= '0' when ",i);
  if(i>l-3) {
             fprintf(fich,"B\"");
             for(j=0;j<puiss(l-1-i);j++)
              fprintf(fich,"0");
            }
  else {
        fprintf(fich,"X\"");
        for(j=0;j<puiss(l-i-3);j++)
         fprintf(fich,"0");
       }
  fprintf(fich,"\" ,\n");
  fprintf(fich,"            '1' when others ;\n");
  if(i<l-1)
  {
   fprintf(fich,"  with wla(%d) select\n",i);
   fprintf(fich,"  wl%d <= wl%d(0 TO %d) when '1',\n",i+1,i,puiss(l-1-i)-1);
   fprintf(fich,"          wl%d(%d TO %d) when '0';\n",i,puiss(l-1-i),puiss(l-i)-1);
  }
 }

 fprintf(fich,"  sl0 <= sel ;\n");
 for(i=0;i<c;i++)
 {
  fprintf(fich,"  with sl%d(0 TO %d) select\n",i,puiss(c-1-i)-1);
  if(c==1) fprintf(fich,"  csa     <= '1' when B\"");
  else fprintf(fich,"  csa(%d) <= '1' when B\"",i);
  for(j=0;j<puiss(c-i-1);j++)
   fprintf(fich,"0");
  fprintf(fich,"\" ,\n");
  fprintf(fich,"            '0' when others ;\n");
  if(i<c-1)
  {
   fprintf(fich,"  with csa(%d) select\n",i);
   fprintf(fich,"  sl%d <= sl%d(0 TO %d) when '0',\n",i+1,i,puiss(c-1-i)-1);
   fprintf(fich,"          sl%d(%d TO %d) when '1';\n",i,puiss(c-1-i),puiss(c-i)-1);
  }
 }
 fprintf(fich,"\n\n\n-- Read Operation --\n\n");
 fprintf(fich,"  with wla(0 TO 3) select\n");
 fprintf(fich,"  msig0 <= mem0 when B\"0000\",\n");
 for(i=1;i<16;i++)
 {
  fprintf(fich,"           mem%d when B\"",i);
  j=i;
  for(k=3;k>=0;k--)
  {
   if(j>=puiss(k)) {
                    fprintf(fich,"1");
                    j = j - puiss(k);
                   }
   else fprintf(fich,"0");
  }
  if(i==15) fprintf(fich,"\";\n");
  else fprintf(fich,"\",\n");
 }
 fprintf(fich,"\n\n");
 fprintf(fich,"  with wla(4 TO %d) select\n",l-1);
 fprintf(fich,"  msig1 <= msig0(0 TO %d) when B\"",puiss(c)-1);
 for(i=0;i<l-4;i++)
  fprintf(fich,"1");
 fprintf(fich,"\",\n");
 for(i=1;i<puiss(l-4);i++)
 {
  fprintf(fich,"           msig0(%d TO %d) when B\"",puiss(c)*i,puiss(c)*(i+1)-1);
  j=i;
  for(k=l-5;k>=0;k--)
  {
   if(j>=puiss(k)) {
                    fprintf(fich,"0");
                    j = j - puiss(k);
                   }
   else fprintf(fich,"1");
  }
  if(i==puiss(l-4)-1) fprintf(fich,"\";\n");
  else fprintf(fich,"\",\n");
 }
 fprintf(fich,"\n\n");
 if(c==1) fprintf(fich,"  with csa select\n");
 else fprintf(fich,"  with csa(0 TO %d) select\n",c-1);
 if(c>=2) k=3;
 else k=c;
 if(u==1){
          fprintf(fich,"  sor <= msig1( %d ) when B\"",k);
         }
 else{
      fprintf(fich,"  kar <= msig1( %d ) when B\"",k);
     }
 for(i=0;i<c;i++)
  fprintf(fich,"0");
 fprintf(fich,"\",\n");
 for(i=1;i<puiss(c);i++)
 {
  fprintf(fich,"         msig1( %d ) when B\"",puiss(c)-1-i);
  j=i;
  for(k=c-1;k>=0;k--)
  {
   if(j>=puiss(k)) {
                    fprintf(fich,"1");
                    j = j - puiss(k);
                   }
   else fprintf(fich,"0");
  }
  fprintf(fich,"\",\n");
 }
 fprintf(fich,"         '0'  when others ;\n");
 fprintf(fich,"\n\n");
 if(u==0){
          fprintf(fich,"  rop:block ( write & read = B\"01\")\n");
          fprintf(fich,"      begin\n");
          fprintf(fich,"            sor <= guarded kar;\n");
          fprintf(fich,"      end block ;\n");
         }
 fprintf(fich,"\n\n");
 fprintf(fich,"-- Write Operation --\n");
 if(u==0){
          name[0]='s';
          name[1]='o';
          name[2]='r';
          name[3]='\0';
         }
 else {
          name[0]='e';
          name[1]='n';
          name[2]='t';
          name[3]='\0';
      }

 switch(c)
 {
   case 1:
          {
           fprintf(fich,"  with csa select\n");
           fprintf(fich,"  msig2 <= msig1(0) & %s when B\"0\" ,\n",name);
           fprintf(fich,"           %s & msig1(1) when B\"1\" ,\n",name);
           fprintf(fich,"           msig1(0 TO 1)  when others ;\n");
           break;
          }
   case 2:
   case 3:
   case 4:
          {
           fprintf(fich,"  with csa(0 TO %d) select\n",c-1);
           fprintf(fich,"  msig2 <= msig1(0 TO %d) & %s when B\"",puiss(c)-2,name);
           for(i=0;i<c;i++)
            fprintf(fich,"0");
           fprintf(fich,"\",\n");
           fprintf(fich,"           msig1(0 TO %d) & %s & msig1(%d) when B\"",puiss(c)-3,name,puiss(c)-1);
           for(i=0;i<c-1;i++)
            fprintf(fich,"0");
           fprintf(fich,"1\",\n");
           for(i=2;i<puiss(c)-2;i++)
           {
            fprintf(fich,"           msig1(0 TO %d) & %s & msig1(%d TO %d) when B\"",puiss(c)-i-2,name,puiss(c)-i,puiss(c)-1);
            j=i;
            for(k=c-1;k>=0;k--)
            {
             if(j>=puiss(k)) {
                              fprintf(fich,"1");
                              j = j - puiss(k);
                             }
             else fprintf(fich,"0");
            }
            fprintf(fich,"\" , \n");
           }
            fprintf(fich,"           msig1( 0 ) & %s & msig1(2 TO %d) when B\"",name,puiss(c)-1);
           for(i=0;i<c-1;i++)
            fprintf(fich,"1");
           fprintf(fich,"0\",\n");
            fprintf(fich,"           %s & msig1(1 TO %d) when B\"10",name,puiss(c)-1);
           for(i=0;i<c;i++)
            fprintf(fich,"1");
           fprintf(fich,"\" ,\n");
           fprintf(fich,"           msig1(0 TO %d)  when others ;\n",puiss(c)-1);
           break;
          }
    default: break;
 }

 fprintf(fich,"\n\n");
 fprintf(fich,"  with wla(4 TO %d) select\n",l-1);
 fprintf(fich,"  msig3 <= msig0(0 TO %d) & msig2(0 TO %d) when B\"",(puiss(l-4)-1)*(puiss(c))-1,puiss(c)-1);
 for(i=0;i<l-4;i++)
  fprintf(fich,"0");
 fprintf(fich,"\",\n");
 for(i=1;i<puiss(l-4)-1;i++)
 {
  fprintf(fich,"           msig0(0 TO %d) & msig2(0 TO %d) & msig0(%d TO %d) when B\"",(puiss(l-4)-(i+1))*puiss(c)-1,puiss(c)-1,(puiss(l-4)-i)*puiss(c),puiss(l+c-4)-1);
  j=i;
  for(k=l-5;k>=0;k--)
  {
   if(j>=puiss(k)) {
                    fprintf(fich,"1");
                    j = j - puiss(k);
                   }
   else fprintf(fich,"0");
  }
  fprintf(fich,"\" , \n");
 }
  fprintf(fich,"           msig2(0 TO %d) & msig0(%d TO %d) when B\"",puiss(c)-1,puiss(c),puiss(l+c-4)-1);
 for(i=0;i<l-4;i++)
  fprintf(fich,"1");
 fprintf(fich,"\";\n");

 fprintf(fich,"\n\n");

 fprintf(fich,"-- Register Write --");
 fprintf(fich,"\n\n");
 for(i=0;i<2;i++)
 {
  for(j=0;j<2;j++)
  {
   for(k=0;k<2;k++)
   {
    for(l=0;l<2;l++)
    {
     fprintf(fich,"msig4(%d) <= ",i*8+j*4+k*2+l);
     if(i==0) fprintf(fich,"not(wla(0)) and ");
     else fprintf(fich,"wla(0) and ");
     if(j==0) fprintf(fich,"not(wla(1)) and ");
     else fprintf(fich,"wla(1) and ");
     if(k==0) fprintf(fich,"not(wla(2)) and ");
     else fprintf(fich,"wla(2) and ");
     if(l==0) fprintf(fich,"not(wla(3));\n");
     else fprintf(fich,"wla(3);\n");
    }
   }
  }
 }
 fprintf(fich,"\n\n");
  
  for(i=0;i<16;i++)
  {
   fprintf(fich," wb%d : block ((write = '0') and not(write'STABLE))\n",i);
   fprintf(fich,"        begin\n");
   fprintf(fich,"        with msig4(%d) select\n",i);
   fprintf(fich,"             mem%d <= GUARDED msig3 when B\"1\",\n",i);
   fprintf(fich,"                              mem%d when B\"0\";\n",i);
   fprintf(fich,"        end block;\n");
   fprintf(fich,"\n\n");
  }
   fprintf(fich,"\n\n");
   fprintf(fich,"\n\n");

 fprintf(fich,"-- End of description --\n");
 fprintf(fich,"end rbitarch ; \n");
 fclose(fich);
}


int gvst2(l,c,n,u,xname)
int l,c,n,u;
char *xname;
{
 FILE *fich;
 int i,j,k;
 char name[100], *p;

 if(*xname != '\0')
  sprintf(name,"%s.vst\0",xname);
 else
   sprintf(name,"mem_%d_%d_%d.vst\0",n*2,l,c);
 
 fich = fopen(name, "w");
 if(*xname != '\0')
  sprintf(name,"%s\0",xname);
 else
   sprintf(name,"mem_%d_%d_%d\0",n*2,l,c);

 fprintf(fich,"ENTITY  %s IS\n",name);
 fprintf(fich,"PORT (\n"); 
 fprintf(fich,"   adr	:	IN BIT_VECTOR(%d DOWNTO 0);\n",l+c-1);
 fprintf(fich,"   write :	IN BIT ;\n");
 fprintf(fich,"   ck	:   	IN BIT ;\n");
 fprintf(fich,"   en	:   	IN BIT ;\n");
 if(u==1){
 fprintf(fich,"   din	:	IN BIT_VECTOR(%d DOWNTO 0);\n",2*n-1);
 fprintf(fich,"   dout	:	OUT BIT_VECTOR(%d DOWNTO 0);\n",2*n-1);
         }
 else {
 fprintf(fich,"   dout	:	INOUT MUX_VECTOR(%d DOWNTO 0) BUS;\n",2*n-1);
      }

 fprintf(fich,"   vdd	:   	linkage BIT ;\n");
 fprintf(fich,"   vss	:   	linkage BIT) ;\n");
 fprintf(fich,"END  %s ;\n",name);
 fprintf(fich,"\n\n\n"); 
 fprintf(fich,"ARCHITECTURE VST OF %s IS \n",name);

 fprintf(fich," \n"); 
 fprintf(fich,"COMPONENT %s_dec\n",name);
 fprintf(fich,"PORT (\n"); 
 fprintf(fich,"   adr	:	IN BIT_VECTOR(%d DOWNTO 0);\n",l+c-1);
 fprintf(fich,"   wld	:	OUT BIT_VECTOR(%d DOWNTO 0);\n",puiss(l)-1);
 fprintf(fich,"   wlg	:	OUT BIT_VECTOR(%d DOWNTO 0);\n",puiss(l)-1);
 fprintf(fich,"   sel	:   	OUT BIT_VECTOR(%d DOWNTO 0);\n",puiss(c)-1);
 fprintf(fich,"   write :	IN BIT ;\n");
 fprintf(fich,"   cpl	:	OUT BIT ;\n");
 fprintf(fich,"   cpr	:	OUT BIT ;\n");
 fprintf(fich,"   cwl	:	OUT BIT ;\n");
 fprintf(fich,"   cwr	:	OUT BIT ;\n");
 fprintf(fich,"   csl	:	OUT BIT ;\n");
 fprintf(fich,"   csr	:	OUT BIT ;\n");
 fprintf(fich,"   ckp	:	OUT BIT ;\n");
 fprintf(fich,"   ckp2	:	OUT BIT ;\n");
 fprintf(fich,"   ck	:   	IN BIT ;\n");
 fprintf(fich,"   en	:   	IN BIT ;\n");
 fprintf(fich,"   vdd	:   	IN BIT ;\n");
 fprintf(fich,"   vss	:   	IN BIT) ;\n");
 fprintf(fich,"END COMPONENT;\n");
 fprintf(fich," \n"); 

 fprintf(fich,"COMPONENT %s_col\n",name);
 fprintf(fich,"PORT (\n");
 fprintf(fich,"   wl    :       IN BIT_VECTOR(0 TO %d);\n",puiss(l)-1);
 fprintf(fich,"   sel   :       IN BIT_VECTOR(0 TO %d);\n",puiss(c)-1);
 fprintf(fich,"   read  :       IN BIT ;\n");
 fprintf(fich,"   write :       IN BIT ;\n");
 fprintf(fich,"   ckp   :       IN BIT ;\n");
 fprintf(fich,"   ckp2  :       IN BIT ;\n");
 if(u==1){
 fprintf(fich,"   ent   :       IN BIT;\n");
 fprintf(fich,"   sor   :       OUT BIT;\n");
         }
 else {
 fprintf(fich,"   sor   :       INOUT MUX_BIT BUS ;\n");
      }
 fprintf(fich,"   vdd   :       IN BIT ;\n");
 fprintf(fich,"   vss   :       IN BIT) ;\n");
 fprintf(fich,"END COMPONENT;\n");

 fprintf(fich," \n"); 
 fprintf(fich," SIGNAL lecd	: BIT;\n"); 
 fprintf(fich," SIGNAL lecg	: BIT;\n"); 
 fprintf(fich," SIGNAL ecrd	: BIT;\n"); 
 fprintf(fich," SIGNAL ecrg	: BIT;\n"); 
 fprintf(fich," SIGNAL prd	: BIT;\n"); 
 fprintf(fich," SIGNAL prg	: BIT;\n"); 
 fprintf(fich," SIGNAL prd2	: BIT;\n"); 
 fprintf(fich," SIGNAL prg2	: BIT;\n"); 
 fprintf(fich," SIGNAL selm	: BIT_VECTOR(0 TO %d);\n",puiss(c)-1); 
 fprintf(fich," SIGNAL wlnd	: BIT_VECTOR(0 TO %d);\n",puiss(l)-1); 
 fprintf(fich," SIGNAL wlng	: BIT_VECTOR(0 TO %d);\n",puiss(l)-1); 
 fprintf(fich," \n\n\n"); 
 fprintf(fich,"BEGIN\n"); 

 fprintf(fich,"   decod : %s_dec\n",name);
 fprintf(fich,"     PORT MAP (\n");
 fprintf(fich,"       adr   => adr,\n");
 fprintf(fich,"       wld    => wlnd,\n");
 fprintf(fich,"       wlg    => wlng,\n");
 fprintf(fich,"       sel   => selm,\n");
 fprintf(fich,"       write => write,\n");
 fprintf(fich,"       cpl   => prg,\n");
 fprintf(fich,"       cpr   => prd,\n");
 fprintf(fich,"       cwl   => ecrg,\n");
 fprintf(fich,"       cwr   => ecrd,\n");
 fprintf(fich,"       csl   => lecg,\n");
 fprintf(fich,"       csr   => lecd,\n");
 fprintf(fich,"       ckp   => prg2,\n");
 fprintf(fich,"       ckp2  => prd2,\n");
 fprintf(fich,"       ck    => ck,\n");
 fprintf(fich,"       en    => en,\n");
 fprintf(fich,"       vdd   => vdd,\n");
 fprintf(fich,"       vss   => vss);\n");
 fprintf(fich," \n"); 

 for(i=0;i<n;i++)
 {
  fprintf(fich,"   bit_%d : %s_col\n",i,name);
  fprintf(fich,"     PORT MAP (\n");
  fprintf(fich,"   wl    => wlng, \n");
  fprintf(fich,"   sel   => selm, \n");
  fprintf(fich,"   read  => lecg, \n");
  fprintf(fich,"   write => ecrg, \n");
  fprintf(fich,"   ckp   => prg, \n");
  fprintf(fich,"   ckp2  => prg2,\n");
  if(u==1){
           fprintf(fich,"   ent   => din(%d), \n",i);
          }
  fprintf(fich,"   sor   => dout(%d), \n",i);
  fprintf(fich,"   vdd   => vdd, \n");
  fprintf(fich,"   vss   => vss ); \n");
  fprintf(fich," \n"); 
 }
 for(i=0;i<n;i++)
 {
  fprintf(fich,"   bit_%d : %s_col\n",i+n,name);
  fprintf(fich,"     PORT MAP (\n");
  fprintf(fich,"   wl    => wlnd, \n");
  fprintf(fich,"   sel   => selm, \n");
  fprintf(fich,"   read  => lecd, \n");
  fprintf(fich,"   write => ecrd, \n");
  fprintf(fich,"   ckp   => prd, \n");
  fprintf(fich,"   ckp2  => prd2,\n");
  if(u==1){
           fprintf(fich,"   ent   => din(%d), \n",i+n);
          }
  fprintf(fich,"   sor   => dout(%d), \n",i+n);
  fprintf(fich,"   vdd   => vdd, \n");
  fprintf(fich,"   vss   => vss ); \n");
  fprintf(fich," \n"); 
 }
 fprintf(fich," END VST;\n");
 fclose(fich);
}

int present()
{
 alliancebanner("RaGe", "2.0", "Ram Generator","1997", ALLIANCE_VERSION);
 /*
 printf("\n\n");
 printf("              @@@@@@          @@@@@\n");
 printf("              @     @        @     @  \n");
 printf("              @     @  @@@@  @        @@@@\n");
 printf("              @@@@@@       @ @  @@@@ @    @\n");
 printf("              @   @    @@@@@ @ @   @ @@@@@@ \n");
 printf("              @    @  @    @ @     @ @\n");
 printf("              @     @  @@@@@  @@@@@   @@@@ \n");
 printf("\n");
 printf("          Alliance CAD system,          RaGe 1.0\n");
 printf("          Tool: RaGe,              RAM Generator\n");
 printf("          (c) copyright 1993 MASI, CAO-VLSI team\n");
 printf("          E-mail support:   cao-vlsi@masi.ibp.fr\n");
 printf("\n\n");
 */
}
