/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 * 
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 * 
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 * 
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 * 
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "genlib.h"

static rsa_pat(n,cin,cout,over,overn,not,csa,sub,addsub,
                deci,stretch,stretch2,name,msb0)
int n,cin,cout,over,overn,not,csa,sub,addsub,
    deci,stretch,stretch2,msb0;
char  *name ;
{
 int  d=msb0?0:n-1;
 int  f=msb0?n-1:0;
 int  l=n-1;
 int  p;
 int  i;
 FILE *fpat;
 int  j;
 char *updown;


   if ( stretch || stretch2 || deci )
      printf("Warning : options deci, stretch, stretch2 are not taken into account for vhdl view\n");

   if( WORK_LIB == NULL ) mbkenv() ;

   fpat = (FILE *)mbkfopen( name, "pat", "w" ) ;

   updown=msb0?GENLIB_NAME("to"):GENLIB_NAME("downto");

               fprintf( fpat, "in a ( %3d %s %3d ) B;;\n",d,updown,f ) ;
               fprintf( fpat, "in b ( %3d %s %3d ) B;;\n",d,updown,f ) ;
   if( csa )   fprintf( fpat, "in c ( %3d %s %3d ) B;;\n",d,updown,f ) ;
   if( cin )   fprintf( fpat, "in cin B;;\n" ) ;
   if( cout )  fprintf( fpat, "out co ( %3d %s %3d ) B;;\n",d,updown,f ) ;
   if( csa )   fprintf( fpat, "out coc B;;\n" ) ;
               fprintf( fpat, "out cout%s B;;\n", (rsa_puiss(n-1)&1) ? "" : "_n" ) ;
   if( over || overn )
               fprintf( fpat, "out over%s B;;\n", (rsa_puiss(n-2)&1) ? "" : "_n" ) ;
               fprintf( fpat, "out s (%3d %s %3d ) B;;\n",d,updown,f ) ;
   if(addsub)  fprintf( fpat, "in sub B;;\n");
               fprintf( fpat, "in vdd B;;\n");
               fprintf( fpat, "in vss B;;\n");
               fprintf( fpat, "\nbegin\n\n" ) ;
               fprintf( fpat, "pat_%8.8X : ",0);
               for(i=0;i<n;i++) fprintf(fpat,"0"); fprintf( fpat, " ");
               for(i=0;i<n;i++) fprintf(fpat,"0"); fprintf( fpat, " ");
   if( csa ) { for(i=0;i<n;i++) fprintf(fpat,"0");fprintf( fpat, " ");}
   if( cin )   fprintf( fpat,"0 ");
   if( cout) { fprintf( fpat, "?");for(i=0;i<n;i++) fprintf(fpat,"0");fprintf( fpat, " ");}
   if( csa )   fprintf( fpat,"- ");
               fprintf( fpat,(rsa_puiss(n-1)&1) ? "- " : "+ " ) ;
   if( over || overn )
               fprintf( fpat,"* ");
               fprintf( fpat, "?");for(i=0;i<n;i++) fprintf(fpat,not?"1":"0"); fprintf( fpat, " ");
   if(addsub)  fprintf( fpat,"0 ");
               fprintf( fpat,"1 0 ;\n\nend;\n");

   fclose(fpat);
}
