/*
 * This file is part of the Alliance CAD System
 * Copyright (C) Laboratoire LIP6 - Dpartement ASIM
 * Universite Pierre et Marie Curie
 *
 * Home page          : http://www-asim.lip6.fr/alliance/
 * E-mail support     : mailto:alliance-support@asim.lip6.fr
 *
 * This progam is  free software; you can redistribute it  and/or modify it
 * under the  terms of the GNU  General Public License as  published by the
 * Free Software Foundation;  either version 2 of the License,  or (at your
 * option) any later version.
 *
 * Alliance VLSI  CAD System  is distributed  in the hope  that it  will be
 * useful, but WITHOUT  ANY WARRANTY; without even the  implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
 * Public License for more details.
 *
 * You should have received a copy  of the GNU General Public License along
 * with the GNU C Library; see the  file COPYING. If not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * Tool    : Logic Synthesis - Netlist Optimisation
 * Date    : 1991,92
 * Author  : Nathalie Dictus
 * Modified by Czo <Olivier.Sirol@lip6.fr> 1996,97
 */



#ident "$Id: netop_systemp.c,v 1.2 2000/11/07 16:15:25 czo Exp $"

#include <stdlib.h>
#include <ctype.h>
#include MUT_H
#include BEH_H
#include MLO_H
#include MPH_H
#include LOG_H

#include "lax_param.h"
#include "sl_local.h"
#include "mapping_local.h"
#include "netop_local.h"

pTH dejaTraite;

/*----------------------------------------------------------------------------
initializeNOParam : initialise les parametres de Netoptim.
------------------------------------------------------------------------------
retour		: un pointeur sur une structure param.
------------------------------------------------------------------------------*/
param *
initializeNOParam (mode, level, intermediate, delayPI, earlyPO, numN, numP, maxSlope, impedancePI, capaPO, capaPI, aux)
     int mode, level;
     chain_list *intermediate;
     ptype_list *delayPI;
     chain_list *earlyPO;
     int numN, numP;
     long maxSlope;
     ptype_list *impedancePI, *capaPO, *capaPI;
     int aux;
{
  param *par = (param *) mbkalloc (sizeof (param));

  par->mode = mode;
  par->level = level;
  par->numTransN = numN;
  par->numTransP = numP;
  par->aux = aux;
  par->maxSlopeTime = maxSlope;
  par->intermediate = intermediate;
  par->delayPI = delayPI;
  par->earlyPO = earlyPO;
  par->impedancePI = impedancePI;
  par->capaPO = capaPO;
  par->capaPI = capaPI;
  return (par);
}

/*----------------------------------------------------------------------------
initializeNOSystem	: alloue no_sys *
------------------------------------------------------------------------------
retour			: un pointeur sur une structure systeme. 
------------------------------------------------------------------------------*/
no_system *
initializeNOSystem ()
{
  no_system *no;

  no = (no_system *) mbkalloc (sizeof (no_system));

  no->name = (char *) mbkalloc (4096);
  no->file = (char *) mbkalloc (4096);
  no->fileOut = (char *) mbkalloc (4096);
  no->filePar = (char *) mbkalloc (4096);
  no->fileLog = (char *) mbkalloc (4096);
  no->fileParam = (char *) mbkalloc (4096);
  no->par_lib = (char *) mbkalloc (4096);
  no->version = (char *) mbkalloc (4096);
  no->cata_lib = (ptype_list *) NULL;

  return (no);

}




